import { ChangeDetectorRef, OnDestroy, OnInit, TemplateRef } from '@angular/core';
import { Subject } from 'rxjs';
import { CascaderService } from './cascader.service';
import { CascaderItem } from './cascader.type';
import * as i0 from "@angular/core";
export declare class CascaderLiComponent implements OnInit, OnDestroy {
    private cascaderSrv;
    private cdr;
    width: number;
    trigger: 'click' | 'hover';
    option: CascaderItem;
    multiple: boolean;
    canSelectParent: boolean;
    colIndex: number;
    dropDownItemTemplate: TemplateRef<any>;
    isLazyLoad: boolean;
    checkboxRelation: {
        upward: boolean;
        downward: boolean;
    };
    dropdownEl: Element;
    isLeaf: boolean;
    selected: boolean;
    halfCheck: boolean;
    active: boolean;
    unsubscribe$: Subject<void>;
    onClick(event: Event): void;
    onMouseEnter(event: any): void;
    constructor(cascaderSrv: CascaderService, cdr: ChangeDetectorRef);
    ngOnInit(): void;
    initObserable(): void;
    clickLeaf(): void;
    clickItem(): void;
    clickCheckbox(event: Event): void;
    avoidCheckboxChange(): boolean;
    updateValue(checked: boolean): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<CascaderLiComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CascaderLiComponent, "d-cascader-li", never, { "width": "width"; "trigger": "trigger"; "option": "option"; "multiple": "multiple"; "canSelectParent": "canSelectParent"; "colIndex": "colIndex"; "dropDownItemTemplate": "dropDownItemTemplate"; "isLazyLoad": "isLazyLoad"; "checkboxRelation": "checkboxRelation"; }, {}, never, never, false, never>;
}
