import { ChangeDetectorRef, EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { I18nInterface, I18nService } from 'ng-devui/i18n';
import { ModalService } from 'ng-devui/modal';
import { Subscription } from 'rxjs';
import * as i0 from "@angular/core";
export interface ColData {
    header: string;
    checked: boolean;
    category?: string;
    disabled?: boolean;
    [prop: string]: any;
}
export interface TableStyleData {
    size?: 'xs' | 'sm' | 'md';
    borderType?: '' | 'borderless';
    striped?: boolean;
    shadowType?: 'embed' | 'normal';
}
export declare class TableOptionToggleComponent implements OnInit, OnDestroy {
    private modalService;
    private cdr;
    private i18n;
    set columnsData(value: Array<ColData>);
    showCategory: boolean;
    colSort: boolean;
    styleSetting: TableStyleData;
    toggleMode: 'dropdown' | 'modal';
    modalWidth: string;
    colChanges: EventEmitter<Array<ColData>>;
    styleChanges: EventEmitter<TableStyleData>;
    _columnsData: any[];
    checkedList: any;
    get showStyleSetting(): boolean;
    get sizeStatus(): any;
    set sizeStatus(value: any);
    i18nText: I18nInterface['datatable'];
    i18nLocale: I18nInterface['locale'];
    i18nSubscription: Subscription;
    constructor(modalService: ModalService, cdr: ChangeDetectorRef, i18n: I18nService);
    ngOnInit(): void;
    onToggle(event: any): void;
    toggleActive(item: any): void;
    onCardActiveChanges(active: boolean, status: 'xs' | 'sm' | 'md'): void;
    emitStyles(): void;
    emitData(): void;
    styleSettingChanges(checked: any, type: 'border' | 'striped' | 'shadow'): void;
    onDrop(e: any): void;
    openModal(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TableOptionToggleComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TableOptionToggleComponent, "d-table-option-toggle", never, { "columnsData": "columnsData"; "showCategory": "showCategory"; "colSort": "colSort"; "styleSetting": "styleSetting"; "toggleMode": "toggleMode"; "modalWidth": "modalWidth"; }, { "colChanges": "colChanges"; "styleChanges": "styleChanges"; }, never, ["*"], false, never>;
}
