import { AfterViewInit, ChangeDetectorRef, ElementRef, EventEmitter, OnDestroy, OnInit, TemplateRef } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { I18nService } from 'ng-devui/i18n';
import { DefaultDateConverter } from 'ng-devui/utils';
import { Subject } from 'rxjs';
import { DatepickerProService } from './datepicker-pro.service';
import { DateConfig } from './lib/datepicker-pro.type';
import * as i0 from "@angular/core";
export declare class RangeDatepickerProComponent implements OnInit, OnDestroy, AfterViewInit, ControlValueAccessor {
    private i18n;
    private pickerSrv;
    private cdr;
    mode: 'year' | 'month' | 'date' | 'week';
    showTime: boolean;
    disabled: boolean;
    autoOpen: boolean;
    format: string;
    locale: string;
    cssClass: string;
    splitter: string;
    width: string;
    startIndexOfWeek: number;
    appendToBody: boolean;
    placeholder: string[];
    allowClear: boolean;
    set calenderRange(value: any);
    set minDate(value: Date);
    set maxDate(value: Date);
    set markedRangeDateList(value: Date[][]);
    set markedDateList(value: Date[]);
    dropdownToggle: EventEmitter<boolean>;
    confirmEvent: EventEmitter<Date[]>;
    customTemplate: TemplateRef<any>;
    footerTemplate: TemplateRef<any>;
    hostTemplate: TemplateRef<any>;
    set markDateInfoTemplate(tmp: TemplateRef<any>);
    datepickerInputStart: ElementRef;
    datepickerInputEnd: ElementRef;
    private i18nLocale;
    i18nText: any;
    _dateValue: any[];
    datepickerConvert: DefaultDateConverter;
    unsubscribe$: Subject<void>;
    isOpen: boolean;
    strWidth: number;
    get dateValue(): string[];
    set dateValue(value: string[]);
    set currentActiveInput(value: 'start' | 'end');
    get currentActiveInput(): 'start' | 'end';
    get dateConfig(): DateConfig;
    get curFormat(): string;
    get curActiveDate(): Date;
    private onChange;
    private onTouched;
    constructor(i18n: I18nService, pickerSrv: DatepickerProService, cdr: ChangeDetectorRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    private initSrvStatus;
    private initObservable;
    isSameDateAndTimeWrong(): boolean;
    getStrWidth(): void;
    private formatDateToString;
    private setI18nText;
    inputChangeCallback: (type: any) => void;
    inputBlurCallback: (type: any) => void;
    focusChange(type: 'start' | 'end'): void;
    validateDate(value: string): boolean;
    onToggle(isOpen: any): void;
    openDropdown(event: Event): void;
    clear(event?: MouseEvent, isHandle?: boolean): void;
    writeValue(value: Date[]): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<RangeDatepickerProComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<RangeDatepickerProComponent, "d-range-datepicker-pro", never, { "mode": "mode"; "showTime": "showTime"; "disabled": "disabled"; "autoOpen": "autoOpen"; "format": "format"; "locale": "locale"; "cssClass": "cssClass"; "splitter": "splitter"; "width": "width"; "startIndexOfWeek": "startIndexOfWeek"; "appendToBody": "appendToBody"; "placeholder": "placeholder"; "allowClear": "allowClear"; "calenderRange": "calenderRange"; "minDate": "minDate"; "maxDate": "maxDate"; "markedRangeDateList": "markedRangeDateList"; "markedDateList": "markedDateList"; }, { "dropdownToggle": "dropdownToggle"; "confirmEvent": "confirmEvent"; }, ["customTemplate", "footerTemplate", "hostTemplate", "markDateInfoTemplate"], never, false, never>;
}
