import { ChangeDetectorRef, ElementRef, EventEmitter, OnChanges, OnInit, Renderer2, SimpleChanges } from '@angular/core';
import { I18nService } from 'ng-devui/i18n';
import { DatePickerConfigService as DatePickerConfig } from '../date-picker.config.service';
import { SelectDateRangeChangeEventArgs } from '../date-range-change-event-args.model';
import { DatepickerComponent as SingleDatepickerComponent } from '../datepicker.component';
import { SimpleDate } from '../single-date-range-picker.component';
import * as i0 from "@angular/core";
export declare class TwoDatepickerSingleComponent extends SingleDatepickerComponent implements OnChanges, OnInit {
    protected elementRef: ElementRef;
    protected renderer: Renderer2;
    protected datePickerConfig: DatePickerConfig;
    protected changeDetectorRef: ChangeDetectorRef;
    protected i18n: I18nService;
    selectedRange: Date[];
    rangePicker: boolean;
    isAuxiliary: boolean;
    currentCalendars: any[];
    whichOpen: any;
    hoverOnDate: EventEmitter<any>;
    rangeSelected: EventEmitter<SelectDateRangeChangeEventArgs>;
    rangeSelecting: EventEmitter<SelectDateRangeChangeEventArgs>;
    syncPickerPair: EventEmitter<{}>;
    consolidateTime: EventEmitter<any>;
    rangeStart: any;
    rangeEnd: any;
    previewEnd: any;
    protected selectingRange: boolean;
    constructor(elementRef: ElementRef, renderer: Renderer2, datePickerConfig: DatePickerConfig, changeDetectorRef: ChangeDetectorRef, i18n: I18nService);
    ngOnInit(): void;
    onSelectDate($event: any, date: any, invocation?: any): void;
    emitHoverDate($event: any, date: any): void;
    selectSingle(date: any): void;
    convertDate(date: any): Date;
    selectRange(date: any, passive?: boolean): void;
    rangeChange(range: any): void;
    writeValue(selectedRange: any): void;
    protected notifyValueChange(selectedRange: Date[]): void;
    isSelectDay(date: any): boolean;
    isBetweenDay(date: any): string;
    ngOnChanges(changes: SimpleChanges): void;
    isInRange(date: any): boolean;
    ensureRangeValueOrder(dateRange: any): any;
    onNextMonth(invocation?: any): void;
    hasNextMonth(): boolean;
    onPreMonth(): void;
    hasPreMonth(): boolean;
    hasPreYearOption(): boolean;
    hasNextYearOption(): boolean;
    onPreYear(): void;
    onNextYear(): void;
    isBeforeMoreThanOneMonth(dateA: SimpleDate, dateB: SimpleDate): boolean;
    isAfterMoreThanOneMonth(dateA: SimpleDate, dateB: SimpleDate): boolean;
    isBeforeMoreThanOneYear(dateA: SimpleDate, dateB: SimpleDate): boolean;
    isAfterMoreThanOneYear(dateA: SimpleDate, dateB: SimpleDate): boolean;
    isYearDisable(year: number): boolean;
    isMonthDisable(month: string): boolean;
    onSelectMonth(month: any): void;
    onSelectYear(year: any, $event?: Event): void;
    protected notifyCalenderChange(): void;
    confirmTime(): void;
    protected onSelectDateChanged(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TwoDatepickerSingleComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TwoDatepickerSingleComponent, "d-two-datepicker-single", never, { "selectedRange": "selectedRange"; "rangePicker": "rangePicker"; "isAuxiliary": "isAuxiliary"; "currentCalendars": "currentCalendars"; "whichOpen": "whichOpen"; }, { "hoverOnDate": "hoverOnDate"; "rangeSelected": "rangeSelected"; "rangeSelecting": "rangeSelecting"; "syncPickerPair": "syncPickerPair"; "consolidateTime": "consolidateTime"; }, never, never, false, never>;
}
