import { ElementRef } from '@angular/core';
export declare class Utils {
    /**
     * Polyfill for element.matches.
     * See: https://developer.mozilla.org/en/docs/Web/API/Element/matches#Polyfill
     * element
     */
    static matches(element: any, selectorName: string): boolean;
    /**
     * Applies the specified css class on nativeElement
     * elementRef
     * className
     */
    static addClass(elementRef: ElementRef | any, className: string): void;
    /**
     * Removes the specified class from nativeElement
     * elementRef
     * className
     */
    static removeClass(elementRef: ElementRef | any, className: string): void;
    /**
     * Gets element with valid classList
     *
     * elementRef
     * @returns ElementRef | null
     */
    private static getElementWithValidClassList;
    static slice(args: any, slice?: any, sliceEnd?: any): any[];
    static addElStyles(el: any, styles: any): void;
    static dispatchEventToUnderElement(event: DragEvent, target?: HTMLElement, eventType?: string): DragEvent;
}
