import { __decorate, __metadata } from 'tslib';
import * as i3 from '@angular/common';
import { DOCUMENT, CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { Directive, Input, EventEmitter, Component, Inject, Output, ViewChild, ViewChildren, ContentChildren, NgModule } from '@angular/core';
import { DefaultIcons } from 'ng-devui/tree-select';
import * as i1 from 'ng-devui/utils';
import { DefaultDateConverter, WithConfig, PopperModule } from 'ng-devui/utils';
import { merge, cloneDeep, mergeWith, isEqual } from 'lodash-es';
import { Subject, fromEvent } from 'rxjs';
import { takeUntil, tap, debounceTime } from 'rxjs/operators';
import * as i2 from 'ng-devui/i18n';
import * as i4 from 'ng-devui/form';
import { FormModule } from 'ng-devui/form';
import * as i5 from '@angular/forms';
import { FormsModule } from '@angular/forms';
import * as i6 from 'ng-devui/dropdown';
import { DropDownModule } from 'ng-devui/dropdown';
import * as i7 from 'ng-devui/text-input';
import { TextInputModule } from 'ng-devui/text-input';
import * as i8 from 'ng-devui/search';
import { SearchModule } from 'ng-devui/search';
import * as i9 from 'ng-devui/tags';
import { TagsModule } from 'ng-devui/tags';
import * as i10 from 'ng-devui/button';
import { ButtonModule } from 'ng-devui/button';
import * as i11 from 'ng-devui/checkbox';
import { CheckBoxModule } from 'ng-devui/checkbox';
import * as i12 from 'ng-devui/input-number';
import { InputNumberModule } from 'ng-devui/input-number';
import * as i13 from 'ng-devui/tree';
import { TreeModule } from 'ng-devui/tree';
import * as i14 from 'ng-devui/datepicker-pro';
import { DatepickerProModule } from 'ng-devui/datepicker-pro';
import { LoadingModule } from 'ng-devui/loading';

const ALLOWED_SEARCH_FIELD_TYPES = ['radio', 'checkbox', 'label'];
const COLORS = [
    '#f2f5fc',
    '#e9edfa',
    '#beccfa',
    '#96adfa',
    '#7693f5',
    '#5e7ce0',
    '#526ecc',
    '#465eb8',
    '#3c51a6',
    '#344899',
    '#2a3c85',
    '#ebf6ff',
    '#d1ebff',
    '#b8e0ff',
    '#9ed5ff',
    '#85caff',
    '#6cbfff',
    '#4ea6e6',
    '#3590cc',
    '#207ab3',
    '#0f6999',
    '#035880',
    '#edfff9',
    '#cffcee',
    '#acf2dc',
    '#8be8cb',
    '#6ddebb',
    '#50d4ab',
    '#3ac295',
    '#27b080',
    '#169e6c',
    '#088c58',
    '#007a45',
    '#f0ffe6',
    '#e5ffd4',
    '#d8fcc0',
    '#c5f2a7',
    '#b3e890',
    '#a6dd82',
    '#92cc68',
    '#7eba50',
    '#6ca83b',
    '#5e9629',
    '#518519',
    '#fffbf0',
    '#fff1c2',
    '#ffe794',
    '#ffdc66',
    '#ffd138',
    '#fac20a',
    '#e3aa00',
    '#cc9600',
    '#b58200',
    '#9e6f00',
    '#875c00',
    '#fff3e8',
    '#ffe1c7',
    '#ffd0a6',
    '#ffbf85',
    '#ffad63',
    '#fa9841',
    '#e37d29',
    '#cc6414',
    '#b54e04',
    '#9e3f00',
    '#873400',
    '#ffeeed',
    '#ffd5d4',
    '#ffbcba',
    '#ffa4a1',
    '#ff8b87',
    '#f66f6a',
    '#de504e',
    '#c73636',
    '#b02121',
    '#991111',
    '#820404',
    '#ffedf3',
    '#ffd4e3',
    '#ffbad2',
    '#ffa1c2',
    '#fc86b0',
    '#f3689a',
    '#db4d83',
    '#c4356e',
    '#ad215b',
    '#96114d',
    '#800440',
    '#f5f0ff',
    '#e7d9ff',
    '#d8c2ff',
    '#caabff',
    '#bc94ff',
    '#a97af8',
    '#8a5ce0',
    '#6f42c9',
    '#572db3',
    '#3f1a9c',
    '#2a0c85',
];

class ContentTemplateDirective {
    constructor(template) {
        this.template = template;
    }
}
ContentTemplateDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ContentTemplateDirective, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
ContentTemplateDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.5", type: ContentTemplateDirective, selector: "ng-template[field]", inputs: { field: "field" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: ContentTemplateDirective, decorators: [{
            type: Directive,
            args: [{
                    /* eslint-disable */
                    selector: 'ng-template[field]',
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }]; }, propDecorators: { field: [{
                type: Input
            }] } });

class DefaultTemplateDirective {
    constructor(template) {
        this.template = template;
    }
}
DefaultTemplateDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: DefaultTemplateDirective, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
DefaultTemplateDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "15.1.5", type: DefaultTemplateDirective, selector: "ng-template[type]", inputs: { type: "type" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: DefaultTemplateDirective, decorators: [{
            type: Directive,
            args: [{
                    /* eslint-disable */
                    selector: 'ng-template[type]',
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }]; }, propDecorators: { type: [{
                type: Input
            }] } });

class CategorySearchComponent {
    get showFilterNameClear() {
        return typeof this.filterName === 'string' && this.filterName.length > 0;
    }
    get showExtendedConfig() {
        var _a;
        return (_a = this._extendedConfig.show) !== null && _a !== void 0 ? _a : Boolean(this.selectedTags.length || this.searchKey);
    }
    constructor(devConfigService, doc, i18n) {
        this.devConfigService = devConfigService;
        this.doc = doc;
        this.i18n = i18n;
        this.defaultSearchField = [];
        this.selectedTags = [];
        /**
         * @deprecated
         */
        this.allowClear = true;
        /**
         * @deprecated
         */
        this.allowSave = true;
        /**
         * @deprecated
         */
        this.allowShowMore = false;
        this.toggleScrollToTail = false;
        this.searchKey = '';
        this.inputReadOnly = false;
        this.showSearchCategory = true; // 配置是否显示搜索相关下拉选项
        this.categoryInGroup = false; // 是否按组别显示分类下拉列表
        this.textConfig = {
            keywordName: '',
            createFilter: '',
            filterTitle: '',
            labelConnector: '|',
        };
        this.filterNameRules = [];
        this.styleType = 'default';
        this.searchEvent = new EventEmitter();
        this.selectedTagsChange = new EventEmitter();
        this.createFilterEvent = new EventEmitter();
        this.clearAllEvent = new EventEmitter();
        this.searchKeyChange = new EventEmitter();
        this.treeSearchKey = '';
        this.filterName = '';
        this.searchKeyCache = '';
        this.enterSearch = false;
        this.isShowSavePanel = false;
        this.isSearchCategory = false;
        this.isHover = false;
        this.isFocus = false;
        this.treeNoRecord = false;
        this.showNoDataTips = false;
        this.icons = DefaultIcons;
        this.destroy$ = new Subject();
        this.scrollToTailFlag = true; // 是否在更新标签内容后滚动至输入框的开关
        this.DROPDOWN_ANIMATION_TIMEOUT = 200; // 下拉动画延迟
        this.DELAY = 300; // 防抖延迟
        this.templates = {}; // 所有类型默认模板
        this.customTemplates = {}; // 按field标记的自定义模板集合
        this.joinLabelTypes = ['checkbox', 'label'];
        this.valueIsArrayTypes = ['numberRange', 'treeSelect'];
        this._extendedConfig = {
            clear: { show: true },
            save: { show: true },
            more: { show: false },
        };
        this.document = this.doc;
        this.dateConverter = new DefaultDateConverter();
        this.id = CategorySearchComponent.ID_SEED++;
        this.showSearchConfig = { keyword: true, field: true, category: true };
        this.i18n
            .langChange()
            .pipe(takeUntil(this.destroy$))
            .subscribe((data) => this.setI18nAndFilterText(data));
    }
    ngOnChanges(changes) {
        const { defaultSearchField, category, extendedConfig, selectedTags, searchKey, showSearchCategory, tagMaxWidth, textConfig } = changes;
        if (defaultSearchField || category || selectedTags) {
            this.init();
        }
        if (searchKey) {
            this.setSearchKeyTag(false);
        }
        if (showSearchCategory) {
            this.setSearchShow();
        }
        if (tagMaxWidth) {
            this.setTagsMaxWidth();
        }
        if (textConfig) {
            this.setI18nAndFilterText(this.i18n.getI18nText());
        }
        if (extendedConfig) {
            this.setExtendedConfig();
        }
    }
    ngAfterViewInit() {
        // 获取所有默认模板，规避脏检查添加延时
        setTimeout(() => this.defaultTemplates.forEach((item) => {
            this.templates[item.type] = item.template;
        }));
        if (this.scrollBarContainer && this.inputEle) {
            // 初始化如果有滚动条直接位移至输入框
            this.scrollToTail(true);
            // 监听滚动事件，在跳转至指定标签后触发其下拉列表
            fromEvent(this.scrollBarContainer.nativeElement, 'scroll')
                .pipe(takeUntil(this.destroy$), tap(() => {
                // 指定标签在可视范围则展开下拉，不在可视范围，即触发滚动后清除定时的展开下拉动作
                if (this.scrollTimeout) {
                    clearTimeout(this.scrollTimeout);
                    this.scrollTimeout = undefined;
                }
                // TODO: 无法区分手动和自动滚动，待处理滚动时关闭已打开的下拉
            }), 
            // 300毫秒内不再触发滚动事件则展开下拉列表
            debounceTime(this.DELAY))
                .subscribe((event) => this.openCurrentScrollTagMenu(event));
        }
    }
    ngAfterContentInit() {
        this.setCustomTemplate(this.contentTemplates);
        this.contentTemplates.changes.subscribe((data) => this.setCustomTemplate(data));
    }
    ngOnDestroy() {
        this.destroy$.next();
        this.destroy$.complete();
    }
    setCustomTemplate(data) {
        if ((data === null || data === void 0 ? void 0 : data.length) && this.category) {
            this.customTemplates = {};
            data.forEach((item) => {
                this.customTemplates[item.field] = item.template;
            });
            this.category.forEach((tag) => {
                tag.customTemplate = this.customTemplates[tag.field];
            });
            this.selectedTags.forEach((tag) => {
                tag.customTemplate = this.customTemplates[tag.field];
            });
        }
    }
    setI18nAndFilterText(data) {
        var _a, _b, _c;
        this.i18nCommonText = data.common;
        this.i18nCategorySearchText = data.categorySearch;
        this.textConfig.createFilter = this.textConfig.createFilter || ((_a = this.i18nCategorySearchText) === null || _a === void 0 ? void 0 : _a.saveFilter);
        this.textConfig.filterTitle = this.textConfig.filterTitle || ((_b = this.i18nCategorySearchText) === null || _b === void 0 ? void 0 : _b.filterTitle);
        this.showSearchConfig.keywordDescription =
            this.showSearchCategory['keywordDescription'] || this.i18nCategorySearchText.getSearchMessage;
        this.showSearchConfig.fieldDescription = this.showSearchCategory['fieldDescription'] || this.i18nCategorySearchText.getFindingMessage;
        this.showSearchConfig.categoryDescription =
            this.showSearchCategory['categoryDescription'] || this.i18nCategorySearchText.selectFilterCondition;
        // 关键字分类内文本不能随语言对象变化，需重新赋值
        const keyword = this.selectedTags.find((item) => item.field === 'devuiCategorySearchKeyword');
        if (keyword) {
            keyword.label = this.textConfig.keywordName || this.i18nCategorySearchText['keyword'];
            keyword.title = `${keyword.label}:${(_c = keyword.value) === null || _c === void 0 ? void 0 : _c.label}`;
        }
    }
    // 插入tag max-width 样式控制是否显示省略号
    setTagsMaxWidth() {
        if (this.tagMaxWidth) {
            const rule = `.devui-category-search-id-${this.id} .devui-tag-container d-tag>.devui-tag-item>span{max-width:${this.tagMaxWidth}px}`;
            const style = this.document.createElement('style');
            style.innerText = rule;
            this.document.head.appendChild(style);
        }
    }
    setSearchShow() {
        const customConfig = typeof this.showSearchCategory === 'boolean'
            ? {
                keyword: this.showSearchCategory,
                field: this.showSearchCategory,
                category: this.showSearchCategory,
            }
            : this.showSearchCategory;
        this.showSearchConfig = Object.assign(Object.assign({}, this.showSearchConfig), customConfig);
    }
    setSearchKeyTag(isSearch = true) {
        const result = this.searchKey || this.searchKeyCache;
        if (this.showSearchConfig.keyword && !this.currentSelectTag) {
            const existingSearchKeyTag = this.selectedTags.find((tag) => tag.field === 'devuiCategorySearchKeyword');
            if (existingSearchKeyTag && !isSearch && this.searchKey === '') {
                this.removeTag(existingSearchKeyTag);
            }
            else if (this.searchKey && this.searchKey !== (existingSearchKeyTag === null || existingSearchKeyTag === void 0 ? void 0 : existingSearchKeyTag.value.value)) {
                this.createSearchKeyTag(isSearch);
            }
        }
        this.searchKey = '';
        if (isSearch) {
            setTimeout(() => {
                this.enterSearch = false;
            }, this.DELAY);
        }
        return result;
    }
    createSearchKeyTag(isSearch) {
        const label = this.textConfig.keywordName || this.i18nCategorySearchText['keyword'];
        const searchKeyTag = {
            options: [],
            field: 'devuiCategorySearchKeyword',
            label: label,
            type: 'keyword',
            title: `${label}:${this.searchKey}`,
            value: {
                label: this.searchKey,
                value: this.searchKey,
                cache: this.searchKey,
            },
        };
        this.updateSelectedTags(searchKeyTag, isSearch);
        this.searchKeyCache = this.searchKey;
        this.searchKey = '';
    }
    setExtendedConfig() {
        const oldConfig = {
            clear: { show: this.allowClear },
            save: { show: this.allowSave },
            more: { show: this.allowShowMore },
        };
        merge(oldConfig, this.extendedConfig);
        merge(this._extendedConfig, oldConfig);
    }
    init() {
        this.setValue(this.category);
        this.setValue(this.selectedTags, true);
        this.initCategoryDisplay();
        if (this.defaultSearchField && this.defaultSearchField.length) {
            this.searchField = this.category.filter((item) => this.defaultSearchField.includes(item.field) && ALLOWED_SEARCH_FIELD_TYPES.includes(item.type));
        }
        // 初始化时判断已选中分类中最后一项是否赋值，未赋值则识别为正在处理的分类，优先显示赋值下拉列表
        if (this.selectedTags.length) {
            const [lastItem] = this.selectedTags.slice(-1);
            const isNull = lastItem.value[lastItem.filterKey || 'label'] === undefined;
            this.currentSelectTag =
                isNull && (lastItem.value.value === undefined || (Array.isArray(lastItem.value.value) && lastItem.value.value.length === 0))
                    ? lastItem
                    : undefined;
        }
        if (this.searchKeyCache) {
            this.searchKey = this.searchKeyCache;
            this.setSearchKeyTag(false);
        }
    }
    // 初始化tag的value属性：{filterKey | label, value, data}
    initCategoryItem(item) {
        const preValue = this.valueIsArrayTypes.includes(item.type) ? { value: [] } : { value: undefined };
        preValue[item.filterKey || 'label'] = undefined;
        if (item.value) {
            for (const prop in preValue) {
                if (item.value[prop] === undefined) {
                    item.value[prop] = preValue[prop];
                }
            }
        }
        else {
            item.value = preValue;
        }
        item.value.cache = (item.value.value && typeof item.value.value === 'object' && cloneDeep(item.value.value)) || item.value.value;
        if (item.type === 'treeSelect' && item.options && item.options.length) {
            item.value.options = cloneDeep(item.options);
        }
        item.customTemplate = this.customTemplates[item.field] || item.customTemplate;
        return item;
    }
    mergeCheck(objValue, srcValue, key) {
        if (key === 'options' && objValue !== srcValue) {
            return srcValue;
        }
    }
    setValue(data, isSelectedTags = false) {
        if (Array.isArray(data) && data.length) {
            data.forEach((item) => {
                if (isSelectedTags) {
                    let result = '';
                    const originItem = this.category.find((categoryItem) => categoryItem.field === item.field);
                    mergeWith(item, originItem, this.mergeCheck);
                    if (item.value.value) {
                        item.value.cache = cloneDeep(item.value.value);
                        result = this.joinLabelTypes.includes(item.type) ? this.getItemValue(item.value.value, item.filterKey || 'label') : '';
                    }
                    item.title = this.setTitle(item, item.type, result);
                    if (item.type === 'label' && item.options[0] && !item.options[0].$label) {
                        this.mergeToLabel(item);
                    }
                }
                else {
                    item = this.initCategoryItem(item);
                }
            });
        }
    }
    setTitle(tag, type, result) {
        return this.joinLabelTypes.includes(type)
            ? `${tag.label}: ${result || ''}`
            : `${tag.label}: ${result || (tag.value && tag.value[tag.filterKey || 'label']) || ''}`;
    }
    initCategoryDisplay() {
        const selectedTagsField = this.selectedTags.map((item) => item.field);
        if (this.categoryInGroup) {
            const groupObj = {};
            this.category.forEach((item) => this.insertCategoryToGroup(item.group, groupObj, item, selectedTagsField.indexOf(item.field) === -1));
            const keys = this.groupOrderConfig || Object.keys(groupObj);
            this.categoryDisplay = [];
            keys.forEach((key) => {
                if (groupObj[key]) {
                    const groupItem = {};
                    groupItem.groupName = key;
                    groupItem.groupLength = groupObj[key].length;
                    this.categoryDisplay.push(groupItem, ...groupObj[key]);
                }
            });
        }
        else {
            this.categoryDisplay =
                selectedTagsField && selectedTagsField.length
                    ? this.category.filter((item) => selectedTagsField.indexOf(item.field) === -1)
                    : this.category;
        }
    }
    insertCategoryToGroup(groupName, groupObj, item, isInsert) {
        if (!groupName) {
            return;
        }
        groupObj[groupName] = groupObj[groupName] || [];
        if (isInsert) {
            groupObj[groupName].push(item);
        }
    }
    search() {
        this.searchEvent.emit({
            selectedTags: this.getSelectedTagsExceptKeyword(),
            searchKey: this.setSearchKeyTag(),
        });
        this.isFocus = true;
    }
    searchCategory(item, value) {
        const validField = item;
        this.updateFieldValue(validField, value || this.searchKey);
        this.updateSelectedTags(validField);
        this.searchKey = '';
        this.enterSearch = false;
        this.finishChoose();
    }
    searchInputValue(event) {
        event.preventDefault();
        event.stopPropagation();
        this.searchEvent.emit({
            selectedTags: this.getSelectedTagsExceptKeyword(),
            searchKey: this.setSearchKeyTag(),
        });
    }
    chooseCategory(item, inputDropdown) {
        // 点选分组名称不处理
        if (item.groupLength !== undefined) {
            return;
        }
        setTimeout(() => {
            this.currentSelectTag = item;
            if (this.currentSelectTag.type === 'label') {
                this.currentSelectTag = this.mergeToLabel(this.currentSelectTag);
            }
            inputDropdown.isOpen = true;
        }, this.DROPDOWN_ANIMATION_TIMEOUT);
        this.updateSelectedTags(item, false);
    }
    getSelectedTagsExceptKeyword() {
        return this.showSearchConfig.keyword
            ? this.selectedTags.filter((item) => item.field !== 'devuiCategorySearchKeyword')
            : this.selectedTags;
    }
    updateSelectedTags(tag, valueChanged = true) {
        this.canChange(tag, 'add').then((val) => {
            if (!val) {
                return;
            }
            const index = this.selectedTags.map((item) => item.field).indexOf(tag.field);
            if (index > -1) {
                if (!tag.value.value) {
                    // 通过输入选择分类时避免空值覆盖已选值
                    merge(tag, this.selectedTags[index]);
                }
                this.selectedTags[index] = tag;
            }
            else {
                this.selectedTags.push(tag);
            }
            this.resolveCategoryDisplay(tag, 'delete');
            if (valueChanged) {
                // 只在新增标签时位移滚动条
                if (this.scrollToTailFlag) {
                    setTimeout(() => this.scrollToTail());
                }
                this.selectedTagsChange.emit({
                    selectedTags: this.getSelectedTagsExceptKeyword(),
                    currentChangeTag: tag,
                    operation: 'add',
                });
                this.isSearchCategory = false;
            }
        });
    }
    // 判断滚动条是否存在，如果存在自动滚动到末尾的输入框
    scrollToTail(isInit) {
        const dom = this.scrollBarContainer.nativeElement;
        if (this.toggleScrollToTail && dom.scrollWidth > dom.clientWidth) {
            if (isInit) {
                dom.scrollLeft = dom.scrollWidth - dom.clientWidth;
            }
            else {
                this.inputEle.nativeElement.scrollIntoView({ behavior: 'smooth', block: 'nearest', inline: 'nearest' });
            }
        }
        else if (!isInit) {
            // 初始化不聚焦，避免展开下拉
            this.inputEle.nativeElement.focus();
        }
    }
    // 滚动至指定的tag
    scrollToTag(index, event) {
        var _a;
        const tags = (_a = this.scrollBarContainer) === null || _a === void 0 ? void 0 : _a.nativeElement.querySelectorAll('ul.devui-category-search-line>li');
        if (tags[index]) {
            this.currentScrollTagIndex = index;
            tags[index].scrollIntoView({ behavior: 'smooth', block: 'nearest', inline: 'nearest' });
            this.scrollTimeout = setTimeout(() => this.openCurrentScrollTagMenu(event), this.DELAY);
        }
    }
    openCurrentScrollTagMenu(event) {
        if (this.currentScrollTagIndex !== undefined) {
            const dropdownArr = this.selectedDropdownList.toArray();
            this.openMenu(dropdownArr[this.currentScrollTagIndex], event);
            this.currentScrollTagIndex = undefined;
        }
    }
    updateFieldValue(field, value) {
        const result = {};
        const filterKey = field.filterKey || 'label';
        const colorKey = field.colorKey || 'color';
        result[filterKey] = value;
        if (field.type === 'radio') {
            field.value.value = { [filterKey]: value };
            field.title = this.setTitle(field, 'radio', value);
        }
        if (field.type === 'label') {
            if (field.options[0] && !field.options[0].$label) {
                this.mergeToLabel(field);
            }
            result[colorKey] = COLORS[Math.floor(COLORS.length * Math.random())];
            result['$label'] = `${value}_${result[colorKey]}`;
        }
        if (['label', 'checkbox'].includes(field.type)) {
            field.value.value = [result];
            // setTitle中checkbox与label同样处理，不需要针对label修改类型参数
            field.title = this.setTitle(field, 'checkbox', value);
        }
        field.value[filterKey] = value;
        field.value.cache = cloneDeep(field.value.value);
    }
    removeTag(tag, event) {
        this.canChange(tag, 'delete').then((val) => {
            if (!val) {
                if (this.beforeTagChange && event) {
                    event.stopPropagation();
                }
                return;
            }
            tag = this.resetValue(tag);
            this.selectedTags = this.selectedTags.filter((item) => item.field !== tag.field);
            const result = this.getSelectedTagsExceptKeyword();
            if (tag.type === 'keyword') {
                this.searchKey = this.searchKey === this.searchKeyCache ? '' : this.searchKey;
                this.searchKeyCache = '';
                this.enterSearch = this.searchKey !== '';
                this.searchEvent.emit({ selectedTags: result, searchKey: this.searchKey });
            }
            else {
                this.resolveCategoryDisplay(tag, 'add');
                this.selectedTagsChange.emit({ selectedTags: result, currentChangeTag: tag, operation: 'delete' });
            }
            this.currentSelectTag = undefined;
        });
    }
    checkInputSearching() {
        this.isFocus = true;
        if (this.searchKey === '') {
            this.enterSearch = false;
        }
        else {
            this.enterSearch = true;
        }
    }
    // 解决dropdownMenu展开时焦点会自动到toggle上的问题
    focusInput() {
        setTimeout(() => {
            this.inputEle.nativeElement.focus();
        });
    }
    // 失焦时关闭当前下拉列表，延时用以防止关闭掉点击分类展开的内容列表
    blurInput(event) {
        this.blurTimer = setTimeout(() => {
            const className = event.relatedTarget && event.relatedTarget['className'];
            const outsideHost = !className || (typeof className === 'string' && className.indexOf(`devui-category-dropdown-menu-${this.id}`) === -1);
            if (!this.currentSelectTag && this.currentOpenDropdown && outsideHost) {
                this.currentOpenDropdown.isOpen = false;
            }
        }, this.DELAY);
    }
    openMenu(inputDropdown, event) {
        const code = event['code'];
        if (inputDropdown.isOpen || (event.type === 'keyup' && ['Enter', 'Backspace', 'Escape'].includes(code))) {
            return;
        }
        setTimeout(() => {
            if (!inputDropdown.isOpen) {
                inputDropdown.toggle();
            }
        });
    }
    closeMenu(inputDropdown) {
        if (inputDropdown.isOpen) {
            inputDropdown.toggle();
        }
    }
    backspaceEvent(inputDropdown) {
        if (this.searchKey) {
            return;
        }
        if (this.currentSelectTag) {
            this.currentSelectTag = undefined;
            this.closeMenu(inputDropdown);
            return;
        }
        if (this.selectedTags.length) {
            const tag = this.selectedTags[this.selectedTags.length - 1];
            this.removeTag(tag);
        }
        this.closeMenu(inputDropdown);
    }
    canChange(tag, operation) {
        let changeResult = Promise.resolve(true);
        if (this.beforeTagChange) {
            const result = this.beforeTagChange(tag, this.searchKey, operation);
            if (typeof result !== 'undefined') {
                if (result.then) {
                    changeResult = result;
                }
                else if (result.subscribe) {
                    changeResult = result.toPromise();
                }
                else {
                    changeResult = Promise.resolve(result);
                }
            }
        }
        return changeResult;
    }
    finishChoose() {
        this.currentSelectTag = undefined;
        this.inputEle.nativeElement.focus();
    }
    clearFilter(event) {
        if (this.selectedTags.length) {
            this.selectedTags.forEach((item) => this.resetValue(item));
            this.selectedTags = [];
        }
        if (this.searchKey || this.searchKeyCache) {
            this.searchKey = '';
            this.searchKeyCache = '';
        }
        if (this.currentSelectTag) {
            this.currentSelectTag = undefined;
        }
        this.selectedTagsChange.emit({ selectedTags: [], currentChangeTag: undefined, operation: 'clear' });
        this.clearAllEvent.emit(event);
        this.initCategoryDisplay();
    }
    resolveCategoryDisplay(tag, type) {
        if (tag && type === 'add') {
            if (this.categoryInGroup) {
                const groupIndex = this.categoryDisplay.findIndex((item) => item.groupName === tag.group);
                this.categoryDisplay[groupIndex].groupLength++;
                this.categoryDisplay.splice(groupIndex + 1, 0, tag);
            }
            else {
                this.categoryDisplay.push(tag);
            }
        }
        if (type === 'delete') {
            if (this.categoryInGroup) {
                const tagIndex = this.categoryDisplay.findIndex((item) => item.field === tag.field);
                if (tagIndex >= 0) {
                    const groupIndex = this.categoryDisplay.findIndex((item) => item.groupName === tag.group);
                    this.categoryDisplay[groupIndex].groupLength--;
                    this.categoryDisplay.splice(tagIndex, 1);
                }
            }
            else {
                this.categoryDisplay = this.categoryDisplay.filter((item) => item.field !== tag.field);
            }
        }
    }
    createFilterFn() {
        this.createFilterEvent.emit({ name: this.filterName, selectedTags: this.getSelectedTagsExceptKeyword(), keyword: this.searchKey });
        setTimeout(() => {
            this.filterName = '';
        }, this.DELAY);
    }
    createFilterInputAutoFocus(dropdown, inputElm, filterNameForm) {
        if (dropdown.isOpen) {
            filterNameForm.form.reset();
            setTimeout(() => inputElm.focus());
        }
    }
    searchKeyChangeEvent(event) {
        this.searchKey = event;
        this.enterSearch = !!event;
        this.currentSearchCategory = event ? this.category.filter((item) => item['label'].toLowerCase().includes(event.toLowerCase())) : [];
        this.searchKeyChange.emit(event);
    }
    checkType(tag) {
        return tag && tag.type === 'radio' ? 'all' : 'blank';
    }
    resetValue(tag) {
        tag.value = this.valueIsArrayTypes.includes(tag.type) ? { value: [] } : { value: undefined };
        tag.value[tag.filterKey || 'label'] = undefined;
        return tag;
    }
    afterDropdownClosed() {
        setTimeout(() => {
            this.currentSelectTag = undefined;
        }, this.DROPDOWN_ANIMATION_TIMEOUT + 100);
    }
    /* 各类型模板调用方法 */
    // radio 单选 处理选中项方法
    chooseItem(tag, chooseItem) {
        this.afterDropdownClosed();
        const key = tag.filterKey || 'label';
        tag.value = { value: chooseItem, cache: cloneDeep(chooseItem) };
        tag.value[key] = chooseItem[key];
        tag.title = this.setTitle(tag, 'radio');
        this.updateSelectedTags(tag);
    }
    confirmDate(datepicker, tag, dropdown) {
        if (!tag.value.value) {
            return;
        }
        if (datepicker.currentActiveInput === 'start') {
            datepicker.focusChange('end');
        }
        else if (!tag.value.value[0]) {
            datepicker.focusChange('start');
        }
        else if (tag.value.value.length > 1) {
            this.closeMenu(dropdown);
            this.afterDropdownClosed();
            const start = tag.value.value[0];
            const end = tag.value.value[1];
            tag.value.cache = cloneDeep(tag.value.value);
            tag.value[tag.filterKey || 'label'] = tag.showTime
                ? `${this.dateConverter.formatDateTime(start)} - ${this.dateConverter.formatDateTime(end)}`
                : `${this.dateConverter.format(start)} - ${this.dateConverter.format(end)}`;
            tag.title = this.setTitle(tag, 'dateRange');
            this.updateSelectedTags(tag);
        }
    }
    // checkbox | label 多选 处理选中项方法
    chooseItems(tag) {
        this.afterDropdownClosed();
        const key = tag.filterKey || 'label';
        const result = this.getItemValue(tag.value.value, key);
        if (result) {
            tag.title = this.setTitle(tag, 'checkbox', result);
            tag.value[key] = result;
            tag.value.cache = cloneDeep(tag.value.value);
            this.updateSelectedTags(tag);
        }
        else {
            this.removeTag(tag);
        }
    }
    // checkbox | label 将选中项对应filterKey的值合并的方法，当前多选已通过data展示，可考虑移除
    getItemValue(value, key) {
        if (value && Array.isArray(value)) {
            const result = value.map((item) => item[key]);
            return result.join(',');
        }
    }
    // checkbox | label 当下拉菜单展开重置多选的选中状态
    resetContent(dropdown, tag) {
        const tagItem = tag || this.currentSelectTag || { type: '', options: [] };
        if (this.blurTimer) {
            clearTimeout(this.blurTimer);
        }
        if (this.toggleEvent) {
            this.toggleEvent(dropdown, tag, this.currentSelectTag);
        }
        if (dropdown.isOpen) {
            this.currentOpenDropdown = dropdown;
            if ((tag === null || tag === void 0 ? void 0 : tag.type) === 'keyword') {
                this.searchKey = this.searchKeyCache;
                this.searchKeyChangeEvent(this.searchKey);
                this.inputEle.nativeElement.focus();
                dropdown.isOpen = false;
            }
        }
        else {
            this.clearCurrentSelectTagFromSearch();
            this.currentOpenDropdown = undefined;
            this.showNoDataTips = false;
            this.resetTreeRender(dropdown, tagItem, false);
            return;
        }
        if (tag) {
            this.scrollToTailFlag = false;
            this.resetTreeRender(dropdown, tagItem, true);
            if (!isEqual(tag.value.value, tag.value.cache)) {
                tag.value.value = cloneDeep(tag.value.cache);
                this.handleAccordingType(tag.type, tag.value.options);
            }
        }
        else if (this.currentSelectTag) {
            this.currentSelectTag.value.value = this.valueIsArrayTypes.includes(this.currentSelectTag.type) ? [] : undefined;
            this.resetTreeRender(dropdown, tagItem, true, true);
            this.handleAccordingType(this.currentSelectTag.type, this.currentSelectTag.options);
            this.scrollToTailFlag = true;
        }
        this.showNoDataTips = this.categoryDisplay.length === 0 || !this.categoryDisplay.some((item) => item && item.groupLength === undefined);
    }
    resetTreeRender(dropdown, tag, flag, isCurrentSelectTag) {
        if (tag.type === 'treeSelect') {
            setTimeout(() => {
                this.treeResetFlag = isCurrentSelectTag ? false : flag;
                if (!flag) {
                    this.treeSearch('');
                    return;
                }
                if (tag.searchable) {
                    const dom = dropdown.menuEl.nativeElement.querySelector('.devui-search-container .devui-search>input');
                    if (dom) {
                        dom.focus();
                    }
                }
            }, this.DELAY);
        }
    }
    showCurrentSearchCategory(tag, inputDropdown) {
        this.isSearchCategory = true;
        this.searchKey = '';
        this.closeMenu(inputDropdown);
        this.chooseCategory(tag, inputDropdown);
        setTimeout(() => this.checkInputSearching(), this.DELAY);
    }
    clearCurrentSelectTagFromSearch() {
        if (this.currentSelectTag) {
            if (this.isSearchCategory) {
                this.isSearchCategory = false;
                setTimeout(() => this.finishChoose(), this.DELAY);
            }
        }
    }
    handleAccordingType(type, options) {
        switch (type) {
            case 'treeSelect':
                options = cloneDeep(options);
                break;
            case 'textInput':
                setTimeout(() => {
                    const inputDom = this.document.querySelector('.devui-category-search-type-text-input');
                    if (inputDom) {
                        inputDom.focus();
                    }
                }, this.DROPDOWN_ANIMATION_TIMEOUT);
                break;
            default:
        }
    }
    // label 合并名称和颜色字段赋给tag，待[tag]支持传入对象后可移除
    mergeToLabel(obj) {
        if ((obj === null || obj === void 0 ? void 0 : obj.options) && Array.isArray(obj.options)) {
            obj.options.forEach((item) => {
                item.$label = `${item[obj.filterKey || 'label']}_${item[obj.colorKey || 'color']}`;
            });
        }
        return obj;
    }
    // label 拆分名称和颜色用于下拉选项显示
    splitLabel(key, value) {
        // 初始化选中类别生成标签时，value为label的对象，不需要对值进行操作
        if (typeof value !== 'string') {
            return;
        }
        const res = value && value.split('_');
        const obj = res && { label: res[0], color: res[1] };
        return obj && obj[key];
    }
    // textInput 文本输入框 处理选中项方法
    getTextInputValue(tag) {
        this.afterDropdownClosed();
        tag.value[tag.filterKey || 'label'] = tag.value.cache = tag.value.value;
        tag.title = this.setTitle(tag, 'textInput');
        this.updateSelectedTags(tag);
    }
    // numberRange 数字范围 处理选中项方法
    getNumberRangeValue(tag) {
        this.afterDropdownClosed();
        const startNum = tag.value.value[0] || 0;
        const endNum = tag.value.value[1] || 0;
        tag.value.value = [startNum, endNum];
        tag.value.cache = [startNum, endNum];
        tag.value[tag.filterKey || 'label'] = `${startNum} - ${endNum}`;
        tag.title = this.setTitle(tag, 'numberRange');
        this.updateSelectedTags(tag);
    }
    // treeSelect 树 处理选中项方法
    getTreeValue(tag) {
        this.afterDropdownClosed();
        const result = [];
        const selectedIds = [];
        const data = tag.value.value;
        data.forEach((item) => {
            result.push(item[tag.filterKey || tag.treeNodeTitleKey || 'title']);
            selectedIds.push(item[tag.treeNodeIdKey || 'id']);
        });
        if (result.length) {
            tag.value.options = cloneDeep(tag.options);
            tag.value.cache = cloneDeep(tag.value.value);
            tag.value[tag.filterKey || 'label'] = result.join(',');
            tag.title = this.setTitle(tag, 'treeSelect');
            if (tag.multiple) {
                const halfCheckedIds = [];
                this.treeInstance.nodes.forEach((item) => item.data.halfChecked && halfCheckedIds.push(item.id));
                this.updateTreeData(tag, tag.value.options, selectedIds, halfCheckedIds);
            }
            this.updateSelectedTags(tag);
        }
        else {
            this.removeTag(tag);
        }
    }
    updateTreeData(tag, data, selectedIds, halfCheckedIds) {
        data.forEach((item) => {
            const itemId = item[tag.treeNodeIdKey || 'id'];
            const childData = item[tag.treeNodeChildrenKey || 'children'];
            item.isChecked = selectedIds.includes(itemId);
            item.halfChecked = halfCheckedIds.includes(itemId);
            if (childData && childData.length) {
                this.updateTreeData(tag, childData, selectedIds, halfCheckedIds);
            }
        });
    }
    onOperableNodeChecked(selectedNodes, tag) {
        const selectedValueExtractor = (nodes) => {
            return tag.leafOnly
                ? nodes.filter((node) => !node.data.isParent).map((node) => node.data.originItem)
                : nodes.map((node) => node.data.originItem);
        };
        if (tag.multiple) {
            tag.value.value = selectedValueExtractor(selectedNodes);
        }
    }
    onOperableNodeSelected(selectedNode, tag) {
        if (tag.multiple || (tag.leafOnly && selectedNode.data.isParent)) {
            return;
        }
        if (selectedNode.data.isActive) {
            tag.value.value = [selectedNode.data.originItem];
            this.getTreeValue(tag);
        }
        else {
            selectedNode.data.isActive = true;
        }
    }
    treeSearch(value, searchFn) {
        this.treeSearchKey = value;
        if (this.treeInstance) {
            const searchRes = searchFn
                ? searchFn(this.treeSearchKey, this.treeInstance)
                : this.treeInstance.treeFactory.searchTree(this.treeSearchKey, true);
            if (typeof searchRes === 'boolean') {
                this.treeNoRecord = searchRes;
            }
            else if (Array.isArray(searchRes)) {
                this.treeNoRecord = searchRes.every((res) => !res);
            }
            this.treeInstance.treeFactory.getFlattenNodes();
        }
    }
}
CategorySearchComponent.ID_SEED = 0;
CategorySearchComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: CategorySearchComponent, deps: [{ token: i1.DevConfigService }, { token: DOCUMENT }, { token: i2.I18nService }], target: i0.ɵɵFactoryTarget.Component });
CategorySearchComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.5", type: CategorySearchComponent, selector: "d-category-search", inputs: { category: "category", defaultSearchField: "defaultSearchField", selectedTags: "selectedTags", allowClear: "allowClear", allowSave: "allowSave", allowShowMore: "allowShowMore", extendedConfig: "extendedConfig", toggleScrollToTail: "toggleScrollToTail", searchKey: "searchKey", placeholderText: "placeholderText", inputReadOnly: "inputReadOnly", showSearchCategory: "showSearchCategory", categoryInGroup: "categoryInGroup", groupOrderConfig: "groupOrderConfig", customGroupNameTemplate: "customGroupNameTemplate", tagMaxWidth: "tagMaxWidth", textConfig: "textConfig", filterNameRules: "filterNameRules", beforeTagChange: "beforeTagChange", toggleEvent: "toggleEvent", styleType: "styleType" }, outputs: { searchEvent: "searchEvent", selectedTagsChange: "selectedTagsChange", createFilterEvent: "createFilterEvent", clearAllEvent: "clearAllEvent", searchKeyChange: "searchKeyChange" }, queries: [{ propertyName: "contentTemplates", predicate: ContentTemplateDirective }], viewQueries: [{ propertyName: "inputEle", first: true, predicate: ["InputEle"], descendants: true, static: true }, { propertyName: "scrollBarContainer", first: true, predicate: ["ScrollBarContainer"], descendants: true, static: true }, { propertyName: "primeContainer", first: true, predicate: ["PrimeContainer"], descendants: true, static: true }, { propertyName: "treeInstance", first: true, predicate: ["OperableTree"], descendants: true }, { propertyName: "selectedDropdownList", predicate: ["selectedDropdown"], descendants: true }, { propertyName: "defaultTemplates", predicate: DefaultTemplateDirective, descendants: true }], usesOnChanges: true, ngImport: i0, template: "<div\n  #PrimeContainer\n  class=\"devui-category-search-container devui-category-search-id-{{ id }}\"\n  [ngClass]=\"{ 'container-hover': isHover && !isFocus, 'devui-gray-style': styleType === 'gray' }\"\n  (mouseenter)=\"isHover = true\"\n  (mouseleave)=\"isHover = false\"\n>\n  <div class=\"devui-category-search-icon\" (click)=\"search()\">\n    <svg width=\"16px\" height=\"16px\" viewBox=\"0 0 16 16\" class=\"svg-icon-search\">\n      <g stroke=\"none\" stroke-width=\"1\" fill=\"none\" fill-rule=\"evenodd\">\n        <path\n          d=\"M7,0 C10.8659932,0 14,3.13400675 14,7 C14,8.57190212 13.4818819,10.0227913 12.6071076,11.1912056 L15.7071068,14.2928932 C16.0976311,14.6834175 16.0976311,15.3165825 15.7071068,15.7071068 C15.3466228,16.0675907 14.7793918,16.0953203 14.3871006,15.7902954 L14.2928932,15.7071068 L11.1912056,12.6071076 C10.0227913,13.4818819 8.57190212,14 7,14 C3.13400675,14 5.5067062e-14,10.8659932 5.5067062e-14,7 C5.5067062e-14,3.13400675 3.13400675,0 7,0 Z M7,2 C4.23857625,2 2,4.23857625 2,7 C2,9.76142375 4.23857625,12 7,12 C9.76142375,12 12,9.76142375 12,7 C12,4.23857625 9.76142375,2 7,2 Z\"\n          fill=\"#71757F\"\n        ></path>\n      </g>\n    </svg>\n  </div>\n  <div #ScrollBarContainer class=\"devui-category-search-line-container\">\n    <ul class=\"devui-category-search-line\">\n      <li\n        class=\"devui-tag-item\"\n        *ngFor=\"let item of selectedTags\"\n        #selectedDropdown=\"d-dropdown\"\n        [ngStyle]=\"{ width: tagMaxWidth || '' }\"\n        dDropDown\n        appendToBody\n        dDropDownToggle\n        [appendToBodyDirections]=\"['rightDown', 'rightUp', 'leftDown', 'leftUp']\"\n        [closeScope]=\"checkType(item)\"\n        (toggleEvent)=\"resetContent(selectedDropdown, item)\"\n      >\n        <ng-template\n          [ngTemplateOutlet]=\"joinLabelTypesTemplate\"\n          [ngTemplateOutletContext]=\"{ item: item, isJoinLabelType: joinLabelTypes.includes(item.type) }\"\n        ></ng-template>\n        <div dDropDownMenu class=\"devui-dropdown-menu devui-dropdown-menu-fix\" [ngClass]=\"{ 'max-height': item.type !== 'treeSelect' }\">\n          <ng-template\n            [ngTemplateOutlet]=\"item.customTemplate || templates[item.type]\"\n            [ngTemplateOutletContext]=\"{ tagOption: item, dropdown: selectedDropdown, isSelected: true }\"\n          ></ng-template>\n        </div>\n      </li>\n      <div class=\"devui-category-search-input\">\n        <div\n          class=\"devui-input-container\"\n          #inputDropdown=\"d-dropdown\"\n          dDropDown\n          appendToBody\n          [trigger]=\"'manually'\"\n          [appendToBodyDirections]=\"['rightDown', 'rightUp', 'leftDown', 'leftUp']\"\n          [closeScope]=\"checkType(currentSelectTag)\"\n          (toggleEvent)=\"resetContent(inputDropdown)\"\n        >\n          <div style=\"width: 100%\">\n            <input\n              class=\"devui-category-search-toggle\"\n              autocomplete=\"off\"\n              #InputEle\n              dDropDownToggle\n              [readOnly]=\"inputReadOnly\"\n              [placeholder]=\"placeholderText || i18nCategorySearchText?.searchPlaceholder || ''\"\n              [ngModel]=\"searchKey\"\n              (ngModelChange)=\"searchKeyChangeEvent($event)\"\n              (click)=\"openMenu(inputDropdown, $event)\"\n              (keyup)=\"checkInputSearching(); openMenu(inputDropdown, $event)\"\n              (keydown.backspace)=\"backspaceEvent(inputDropdown)\"\n              (keydown.enter)=\"searchInputValue($event); closeMenu(inputDropdown)\"\n              (focus)=\"isHover = false; isFocus = true\"\n              (blur)=\"isFocus = false; blurInput($event)\"\n            />\n          </div>\n          <div\n            *ngIf=\"!enterSearch || (enterSearch && showSearchCategory)\"\n            dDropDownMenu\n            class=\"devui-dropdown-menu devui-dropdown-menu-fix devui-scrollbar devui-category-dropdown-menu-{{ id }}\"\n            [ngClass]=\"{ 'max-height': currentSelectTag?.type !== 'treeSelect' }\"\n          >\n            <ul *ngIf=\"!currentSelectTag\" class=\"devui-dropdown-menu-template\">\n              <ng-container *ngIf=\"!enterSearch && !currentSelectTag\">\n                <ng-container *ngFor=\"let item of categoryDisplay\">\n                  <li *ngIf=\"item.groupLength\" class=\"devui-dropdown-item devui-category-search-group\">\n                    <ng-template\n                      [ngTemplateOutlet]=\"customGroupNameTemplate || defaultGroupNameTemplate\"\n                      [ngTemplateOutletContext]=\"{ tag: item }\"\n                    ></ng-template>\n                  </li>\n                  <li\n                    *ngIf=\"item.groupLength === undefined\"\n                    class=\"devui-dropdown-item\"\n                    (click)=\"chooseCategory(item, inputDropdown); closeMenu(inputDropdown)\"\n                  >\n                    <span title=\"{{ item?.label }}\">{{ item?.label }}</span>\n                  </li>\n                </ng-container>\n                <div class=\"devui-no-data-text\" *ngIf=\"showNoDataTips\">{{ i18nCategorySearchText?.noFilterConditions }}</div>\n              </ng-container>\n              <ng-container *ngIf=\"enterSearch\">\n                <li\n                  *ngIf=\"showSearchConfig.keyword\"\n                  class=\"devui-dropdown-item devui-search-description\"\n                  (click)=\"searchInputValue($event); closeMenu(inputDropdown)\"\n                >\n                  <span class=\"icon-search\"></span>{{ showSearchConfig.keywordDescription(searchKey) }}\n                </li>\n                <ng-container *ngIf=\"showSearchConfig.field\">\n                  <li *ngFor=\"let item of searchField\" (click)=\"searchCategory(item); closeMenu(inputDropdown)\" class=\"devui-dropdown-item\">\n                    <span class=\"icon-search\"></span>{{ showSearchConfig.fieldDescription(item?.label) }}\n                  </li>\n                </ng-container>\n                <div\n                  *ngIf=\"(showSearchConfig.keyword || showSearchConfig.field) && showSearchConfig.category && currentSearchCategory?.length\"\n                  class=\"devui-dividing-line\"\n                ></div>\n                <ng-container *ngIf=\"showSearchConfig.category && currentSearchCategory?.length\">\n                  <div class=\"devui-dropdown-menu-tip\" [style.paddingBottom]=\"currentSearchCategory.length ? '0' : '12px'\">\n                    {{ showSearchConfig.categoryDescription }}\n                  </div>\n                  <ul class=\"devui-category-search-keyword-in-category devui-dropdown-menu-template\">\n                    <li\n                      *ngFor=\"let item of currentSearchCategory\"\n                      (click)=\"showCurrentSearchCategory(item, inputDropdown)\"\n                      class=\"devui-dropdown-item\"\n                    >\n                      <span>{{ item?.label }}</span>\n                    </li>\n                  </ul>\n                </ng-container>\n              </ng-container>\n            </ul>\n            <ng-container *ngIf=\"!enterSearch && currentSelectTag\">\n              <ng-template\n                [ngTemplateOutlet]=\"currentSelectTag.customTemplate || templates[currentSelectTag.type]\"\n                [ngTemplateOutletContext]=\"{ tagOption: currentSelectTag, dropdown: inputDropdown }\"\n              ></ng-template>\n            </ng-container>\n          </div>\n        </div>\n      </div>\n    </ul>\n  </div>\n  <div class=\"devui-category-search-extended-container\" *ngIf=\"showExtendedConfig\">\n    <ng-template *ngIf=\"_extendedConfig.clear.show\" [ngTemplateOutlet]=\"_extendedConfig.clear.template || clearTpl\"></ng-template>\n    <ng-template *ngIf=\"_extendedConfig.save.show\" [ngTemplateOutlet]=\"_extendedConfig.save.template || saveTpl\"></ng-template>\n    <ng-template *ngIf=\"_extendedConfig.more.show\" [ngTemplateOutlet]=\"_extendedConfig.more.template || moreTpl\"></ng-template>\n    <ng-template *ngIf=\"_extendedConfig.customTemplate\" [ngTemplateOutlet]=\"_extendedConfig.customTemplate\"></ng-template>\n  </div>\n</div>\n\n<ng-template #defaultGroupNameTemplate let-item=\"tag\">\n  <strong>{{ item?.groupName }}</strong>\n</ng-template>\n\n<ng-template #noData>\n  <div class=\"devui-no-data-tip\">{{ i18nCommonText?.noData }}</div>\n</ng-template>\n\n<ng-template #clearTpl>\n  <div\n    class=\"devui-category-search-icon\"\n    [class.disabled]=\"_extendedConfig.clear.disabled\"\n    (click)=\"!_extendedConfig.clear.disabled && clearFilter($event)\"\n  >\n    <svg width=\"16px\" height=\"16px\" viewBox=\"0 0 16 16\">\n      <title>{{ i18nCategorySearchText?.clearFilterCondition }}</title>\n      <g stroke=\"none\" stroke-width=\"1\" fill=\"none\" fill-rule=\"evenodd\">\n        <path\n          d=\"M4.61289944,3.20970461 L4.70710678,3.29289322 L8,6.585 L11.2928932,3.29289322 C11.6834175,2.90236893 12.3165825,2.90236893 12.7071068,3.29289322 C13.0675907,3.65337718 13.0953203,4.22060824 12.7902954,4.61289944 L12.7071068,4.70710678 L9.415,8 L12.7071068,11.2928932 C13.0976311,11.6834175 13.0976311,12.3165825 12.7071068,12.7071068 C12.3466228,13.0675907 11.7793918,13.0953203 11.3871006,12.7902954 L11.2928932,12.7071068 L8,9.415 L4.70710678,12.7071068 C4.31658249,13.0976311 3.68341751,13.0976311 3.29289322,12.7071068 C2.93240926,12.3466228 2.90467972,11.7793918 3.20970461,11.3871006 L3.29289322,11.2928932 L6.585,8 L3.29289322,4.70710678 C2.90236893,4.31658249 2.90236893,3.68341751 3.29289322,3.29289322 C3.65337718,2.93240926 4.22060824,2.90467972 4.61289944,3.20970461 Z\"\n          fill-rule=\"nonzero\"\n        ></path>\n      </g>\n    </svg>\n  </div>\n</ng-template>\n\n<ng-template #saveTpl>\n  <div\n    class=\"devui-category-search-icon\"\n    #saveDropdown=\"d-dropdown\"\n    dDropDown\n    appendToBody\n    [appendToBodyDirections]=\"['rightDown', 'rightUp', 'leftDown', 'leftUp']\"\n    [class.disabled]=\"_extendedConfig.save.disabled\"\n    [closeScope]=\"'blank'\"\n    [disabled]=\"_extendedConfig.save.disabled\"\n    (toggleEvent)=\"createFilterInputAutoFocus(saveDropdown, createFilterInput, filterNameForm)\"\n  >\n    <svg width=\"16px\" height=\"16px\" viewBox=\"0 0 16 16\" version=\"1.1\" dDropDownToggle>\n      <title>{{ textConfig.createFilter }}</title>\n      <g stroke=\"none\" stroke-width=\"1\" fill=\"none\" fill-rule=\"evenodd\">\n        <path\n          d=\"M12,1 L15,4 L15,13 C15,14.1045695 14.1045695,15 13,15 L3,15 C1.8954305,15 1,14.1045695 1,13 L1,3 C1,1.8954305 1.8954305,1 3,1 L12,1 Z M11.171,3 L3,3 L3,13 L4,13 L4,10 C4,9.48716416 4.38604019,9.06449284 4.88337887,9.00672773 L5,9 L11,9 C11.5128358,9 11.9355072,9.38604019 11.9932723,9.88337887 L12,10 L12,13 L13,13 L13,4.829 L11.171,3 Z M9.999,10.999 L5.999,10.999 L6,13 L10,13 L9.999,10.999 Z M7,5 C7.55228475,5 8,5.44771525 8,6 C8,6.55228475 7.55228475,7 7,7 L5,7 C4.44771525,7 4,6.55228475 4,6 C4,5.44771525 4.44771525,5 5,5 L7,5 Z\"\n          fill-rule=\"nonzero\"\n        ></path>\n      </g>\n    </svg>\n    <div dDropDownMenu class=\"devui-save-panel\">\n      <div class=\"devui-save-panel-title\">\n        <span>{{ textConfig.createFilter }}</span>\n      </div>\n      <div class=\"devui-save-filter-name\">\n        <span>{{ textConfig.filterTitle }}</span>\n        <form #filterNameForm=\"ngForm\">\n          <input\n            name=\"filter-name\"\n            class=\"devui-category-search-toggle\"\n            autocomplete=\"off\"\n            #createFilterInput\n            dTextInput\n            [(ngModel)]=\"filterName\"\n            [placeholder]=\"i18nCategorySearchText?.placeholder || ''\"\n            [dValidateRules]=\"filterNameRules\"\n          />\n          <svg\n            *ngIf=\"showFilterNameClear\"\n            (click)=\"$event.preventDefault(); $event.stopPropagation(); filterName = ''\"\n            width=\"16px\"\n            height=\"16px\"\n            viewBox=\"0 0 16 16\"\n          >\n            <title>{{ i18nCategorySearchText?.clearFilterCondition }}</title>\n            <g stroke=\"none\" stroke-width=\"1\" fill=\"none\" fill-rule=\"evenodd\">\n              <path\n                d=\"M4.61289944,3.20970461 L4.70710678,3.29289322 L8,6.585 L11.2928932,3.29289322 C11.6834175,2.90236893 12.3165825,2.90236893 12.7071068,3.29289322 C13.0675907,3.65337718 13.0953203,4.22060824 12.7902954,4.61289944 L12.7071068,4.70710678 L9.415,8 L12.7071068,11.2928932 C13.0976311,11.6834175 13.0976311,12.3165825 12.7071068,12.7071068 C12.3466228,13.0675907 11.7793918,13.0953203 11.3871006,12.7902954 L11.2928932,12.7071068 L8,9.415 L4.70710678,12.7071068 C4.31658249,13.0976311 3.68341751,13.0976311 3.29289322,12.7071068 C2.93240926,12.3466228 2.90467972,11.7793918 3.20970461,11.3871006 L3.29289322,11.2928932 L6.585,8 L3.29289322,4.70710678 C2.90236893,4.31658249 2.90236893,3.68341751 3.29289322,3.29289322 C3.65337718,2.93240926 4.22060824,2.90467972 4.61289944,3.20970461 Z\"\n                fill-rule=\"nonzero\"\n              ></path>\n            </g>\n          </svg>\n        </form>\n      </div>\n      <div class=\"devui-save-panel-operation-area\">\n        <d-button [disabled]=\"filterNameForm.invalid\" (btnClick)=\"createFilterFn(); saveDropdown.toggle()\">{{\n          i18nCategorySearchText?.confirm\n        }}</d-button>\n        <d-button bsStyle=\"common\" (btnClick)=\"saveDropdown.toggle()\">{{ i18nCategorySearchText?.cancel }}</d-button>\n      </div>\n    </div>\n  </div>\n</ng-template>\n\n<ng-template #moreTpl>\n  <div\n    class=\"devui-category-search-icon\"\n    #seeMoreDropdown=\"d-dropdown\"\n    dDropDown\n    appendToBody\n    [alignOrigin]=\"primeContainer\"\n    [appendToBodyDirections]=\"['rightDown', 'rightUp', 'leftDown', 'leftUp']\"\n    [class.disabled]=\"_extendedConfig.more.disabled\"\n  >\n    <svg width=\"16px\" height=\"16px\" viewBox=\"0 0 16 16\" dDropDownToggle>\n      <title>{{ i18nCategorySearchText?.seeMore }}</title>\n      <g stroke=\"none\" stroke-width=\"1\" fill=\"none\" fill-rule=\"evenodd\">\n        <path\n          d=\"M1,2 L3,2 L3,4 L1,4 L1,2 Z M1,7 L3,7 L3,9 L1,9 L1,7 Z M1,12 L3,12 L3,14 L1,14 L1,12 Z M5,2 L15,2 L15,4 L5,4 L5,2 Z M5,7 L15,7 L15,9 L5,9 L5,7 Z M5,12 L15,12 L15,14 L5,14 L5,12 Z\"\n          fill-rule=\"nonzero\"\n        ></path>\n      </g>\n    </svg>\n    <div dDropDownMenu class=\"devui-selected-tags-list\">\n      <ul [ngStyle]=\"{ width: PrimeContainer?.clientWidth + 'px' }\">\n        <li class=\"devui-tag-item\" *ngFor=\"let item of selectedTags; let i = index\" (click)=\"scrollToTag(i, $event)\">\n          <ng-template\n            [ngTemplateOutlet]=\"joinLabelTypesTemplate\"\n            [ngTemplateOutletContext]=\"{ item: item, isJoinLabelType: joinLabelTypes.includes(item.type) }\"\n          ></ng-template>\n        </li>\n      </ul>\n    </div>\n  </div>\n</ng-template>\n\n<ng-template #joinLabelTypesTemplate let-item=\"item\" let-isJoinLabelType=\"isJoinLabelType\">\n  <div class=\"devui-tag-container\">\n    <d-tag\n      [deletable]=\"true\"\n      [tag]=\"isJoinLabelType ? item : item.label + ': ' + (item.value[item.filterKey || 'label'] || '')\"\n      [titleContent]=\"item.title\"\n      [customViewTemplate]=\"item.tagCustomTemplate || (isJoinLabelType && defaultTagContentTemplate)\"\n      (tagDelete)=\"removeTag(item, $event.event)\"\n    ></d-tag>\n  </div>\n</ng-template>\n\n<ng-template #defaultTagContentTemplate let-tag=\"tag\" let-colorKey=\"tag.colorKey || 'color'\">\n  <span>{{ tag.label }}: </span>\n  <ng-container *ngFor=\"let val of tag.value.cache; let i = index\">\n    <span *ngIf=\"i > 0\" class=\"devui-color-block-split-line\">{{ textConfig.labelConnector || '|' }}</span>\n    <span *ngIf=\"tag.type === 'label'\" class=\"devui-color-block-sm\" [style.background]=\"val[colorKey]\"></span>\n    <span [style.color]=\"val[colorKey]\">{{ val[tag.filterKey || 'label'] || '' }}</span>\n  </ng-container>\n</ng-template>\n\n<ng-template [type]=\"'radio'\" let-tagOption=\"tagOption\" let-key=\"tagOption.filterKey || 'label'\">\n  <div *ngIf=\"!tagOption.options?.length\">\n    <ng-container *ngTemplateOutlet=\"noData\"></ng-container>\n  </div>\n  <ul *ngIf=\"tagOption.options?.length\" class=\"devui-dropdown-menu-template devui-scrollbar\">\n    <li\n      *ngFor=\"let item of tagOption.options\"\n      title=\"{{ item[key] }}\"\n      class=\"devui-dropdown-item\"\n      [class.active]=\"tagOption?.value[key] === item[key]\"\n      (click)=\"chooseItem(tagOption, item)\"\n    >\n      <span>{{ item[key] }}</span>\n    </li>\n  </ul>\n</ng-template>\n\n<ng-template [type]=\"'dateRange'\" let-tagOption=\"tagOption\" let-dropdown=\"dropdown\">\n  <d-datepicker-calendar\n    #datepickerCalendarItem\n    *ngIf=\"dropdown.isOpen\"\n    id=\"{{ tagOption.field }}\"\n    style=\"overflow-x: hidden\"\n    #dDatepickerPro\n    [isRangeType]=\"true\"\n    [showTime]=\"tagOption.showTime\"\n    [activeRangeType]=\"tagOption.activeRangeType || 'start'\"\n    [(ngModel)]=\"tagOption.value.value\"\n  >\n    <ng-template #footerTemplate>\n      <div class=\"devui-datepicker-footer\">\n        <d-button\n          style=\"margin-right: 8px\"\n          bsStyle=\"primary\"\n          (btnClick)=\"confirmDate(datepickerCalendarItem, tagOption, dropdown)\"\n          [disabled]=\"\n            tagOption.showTime ? false : !tagOption.value.value || tagOption.value.value.length < 2 || tagOption.value.value.includes(null)\n          \"\n        >\n          {{ i18nCategorySearchText?.confirm }}\n        </d-button>\n        <d-button bsStyle=\"common\" (btnClick)=\"closeMenu(dropdown)\">{{ i18nCategorySearchText?.cancel }}</d-button>\n      </div>\n    </ng-template>\n  </d-datepicker-calendar>\n</ng-template>\n\n<ng-template [type]=\"'checkbox'\" let-tagOption=\"tagOption\" let-dropdown=\"dropdown\">\n  <div *ngIf=\"!tagOption.options?.length\">\n    <ng-container *ngTemplateOutlet=\"noData\"></ng-container>\n  </div>\n  <div *ngIf=\"tagOption.options?.length\" class=\"devui-dropdown-menu-template\">\n    <d-checkbox-group\n      [(ngModel)]=\"tagOption.value.value\"\n      [options]=\"tagOption.options\"\n      [filterKey]=\"tagOption.filterKey || 'label'\"\n      [isShowTitle]=\"true\"\n    >\n    </d-checkbox-group>\n  </div>\n  <div class=\"devui-dropdown-operation-area\">\n    <d-button (btnClick)=\"chooseItems(tagOption); closeMenu(dropdown)\">{{ i18nCategorySearchText?.confirm }}</d-button>\n    <d-button bsStyle=\"common\" (btnClick)=\"closeMenu(dropdown)\">{{ i18nCategorySearchText?.cancel }}</d-button>\n  </div>\n</ng-template>\n\n<ng-template [type]=\"'label'\" let-tagOption=\"tagOption\" let-dropdown=\"dropdown\">\n  <div *ngIf=\"!tagOption.options?.length\">\n    <ng-container *ngTemplateOutlet=\"noData\"></ng-container>\n  </div>\n  <div *ngIf=\"tagOption.options?.length\" class=\"devui-dropdown-menu-template\">\n    <d-checkbox-group\n      [(ngModel)]=\"tagOption.value.value\"\n      [options]=\"tagOption.options\"\n      [filterKey]=\"'$label'\"\n      [labelTemplate]=\"labelContent\"\n      [isShowTitle]=\"true\"\n    >\n      <ng-template #labelContent let-label=\"label\">\n        <span class=\"devui-color-block\" [style.background]=\"splitLabel('color', label)\" title=\"{{ splitLabel('label', label) }}\"></span>\n        <span title=\"{{ splitLabel('label', label) }}\">{{ splitLabel('label', label) }}</span>\n      </ng-template>\n    </d-checkbox-group>\n  </div>\n  <div class=\"devui-dropdown-operation-area\">\n    <d-button (btnClick)=\"chooseItems(tagOption); closeMenu(dropdown)\">{{ i18nCategorySearchText?.confirm }}</d-button>\n    <d-button bsStyle=\"common\" (btnClick)=\"closeMenu(dropdown)\">{{ i18nCategorySearchText?.cancel }}</d-button>\n  </div>\n</ng-template>\n\n<ng-template [type]=\"'textInput'\" let-tagOption=\"tagOption\" let-dropdown=\"dropdown\">\n  <form #textInputForm=\"ngForm\">\n    <input\n      name=\"text-input\"\n      class=\"devui-category-search-type-text-input\"\n      autocomplete=\"off\"\n      dTextInput\n      [(ngModel)]=\"tagOption.value.value\"\n      [maxlength]=\"tagOption.maxLength\"\n      [placeholder]=\"tagOption.placeholder || ''\"\n      [dValidateRules]=\"tagOption.validateRules\"\n    />\n  </form>\n  <div class=\"devui-dropdown-operation-area\">\n    <d-button [disabled]=\"textInputForm.invalid\" (btnClick)=\"getTextInputValue(tagOption); closeMenu(dropdown)\">{{\n      i18nCategorySearchText?.confirm\n    }}</d-button>\n    <d-button bsStyle=\"common\" (btnClick)=\"closeMenu(dropdown)\">{{ i18nCategorySearchText?.cancel }}</d-button>\n  </div>\n</ng-template>\n\n<ng-template [type]=\"'numberRange'\" let-tagOption=\"tagOption\" let-dropdown=\"dropdown\">\n  <div class=\"devui-input-number-operation-area\">\n    <d-input-number\n      size=\"sm\"\n      [min]=\"tagOption.min?.left\"\n      [max]=\"tagOption.max?.left\"\n      [maxLength]=\"tagOption.maxLength?.left\"\n      [step]=\"tagOption.step?.left || 1\"\n      [reg]=\"tagOption.reg?.left\"\n      [placeholder]=\"tagOption.placeholder?.left || ''\"\n      [(ngModel)]=\"tagOption.value.value[0]\"\n    >\n    </d-input-number>\n    <span> - </span>\n    <d-input-number\n      size=\"sm\"\n      [min]=\"tagOption.min?.right\"\n      [max]=\"tagOption.max?.right\"\n      [maxLength]=\"tagOption.maxLength?.right\"\n      [step]=\"tagOption.step?.right || 1\"\n      [reg]=\"tagOption.reg?.right\"\n      [placeholder]=\"tagOption.placeholder?.right || ''\"\n      [(ngModel)]=\"tagOption.value.value[1]\"\n    >\n    </d-input-number>\n  </div>\n  <div class=\"devui-dropdown-operation-area\">\n    <d-button (btnClick)=\"getNumberRangeValue(tagOption); closeMenu(dropdown)\">{{ i18nCategorySearchText?.confirm }}</d-button>\n    <d-button bsStyle=\"common\" (btnClick)=\"closeMenu(dropdown)\">{{ i18nCategorySearchText?.cancel }}</d-button>\n  </div>\n</ng-template>\n\n<ng-template [type]=\"'treeSelect'\" let-tagOption=\"tagOption\" let-dropdown=\"dropdown\" let-isSelected=\"isSelected\">\n  <div *ngIf=\"tagOption.multiple && tagOption.options?.length && tagOption.value.value?.length\">\n    <ul class=\"devui-select-list\">\n      <span>{{ i18nCategorySearchText?.selected }}</span>\n      <li class=\"devui-select-item devui-no-label-item\" *ngFor=\"let item of tagOption.value.value; last as isLast\">\n        {{ item[tagOption.filterKey || tagOption.treeNodeTitleKey || 'title'] }}\n        <span *ngIf=\"!isLast\">, </span>\n      </li>\n    </ul>\n  </div>\n  <div *ngIf=\"tagOption.searchable\" class=\"devui-search-container\">\n    <d-search\n      [placeholder]=\"tagOption.searchPlaceholder\"\n      [ngModel]=\"treeSearchKey\"\n      (ngModelChange)=\"treeSearch($event, tagOption.searchFn)\"\n    ></d-search>\n  </div>\n  <div class=\"devui-category-search-tree-container\" [style.display]=\"tagOption.options?.length && !treeNoRecord ? 'block' : 'none'\">\n    <d-operable-tree\n      #OperableTree\n      *ngIf=\"dropdown.isOpen || treeResetFlag\"\n      class=\"devui-tree\"\n      [tree]=\"isSelected ? tagOption.value.options : tagOption.options\"\n      [treeNodeIdKey]=\"tagOption.treeNodeIdKey || 'id'\"\n      [treeNodeChildrenKey]=\"tagOption.treeNodeChildrenKey || 'children'\"\n      [treeNodeTitleKey]=\"tagOption.filterKey || tagOption.treeNodeTitleKey || 'title'\"\n      [checkboxDisabledKey]=\"tagOption.disabledKey || 'disabled'\"\n      [checkable]=\"tagOption.multiple\"\n      [canActivateNode]=\"!tagOption.multiple\"\n      [canActivateParentNode]=\"!tagOption.leafOnly\"\n      [iconParentOpen]=\"tagOption.iconParentOpen || icons.iconParentOpen\"\n      [iconParentClose]=\"tagOption.iconParentClose || icons.iconParentClose\"\n      [iconLeaf]=\"tagOption.iconLeaf || icons.iconLeaf\"\n      (nodeChecked)=\"onOperableNodeChecked($event, tagOption)\"\n      (nodeSelected)=\"onOperableNodeSelected($event, tagOption); closeMenu(dropdown)\"\n    >\n    </d-operable-tree>\n  </div>\n  <div *ngIf=\"!tagOption.options?.length\">\n    <ng-container *ngTemplateOutlet=\"noData\"></ng-container>\n  </div>\n  <div *ngIf=\"treeNoRecord\" class=\"devui-no-data-tip\">{{ i18nCommonText?.noRecordsFound }}</div>\n  <div *ngIf=\"tagOption.multiple\" class=\"devui-dropdown-operation-area\">\n    <d-button [disabled]=\"!tagOption.value.value?.length\" (btnClick)=\"getTreeValue(tagOption); closeMenu(dropdown)\">{{\n      i18nCategorySearchText?.confirm\n    }}</d-button>\n    <d-button bsStyle=\"common\" (btnClick)=\"closeMenu(dropdown)\">{{ i18nCategorySearchText?.cancel }}</d-button>\n  </div>\n</ng-template>\n", styles: [".devui-font-size-base{font-size:12px;font-size:var(--devui-font-size, 12px)}.devui-font-base{font-size:12px;font-size:var(--devui-font-size, 12px);font-weight:400;line-height:1.5}.devui-font-size-modal-title{font-size:18px;font-size:var(--devui-font-size-modal-title, 18px)}.devui-font-modal-title{font-size:18px;font-size:var(--devui-font-size-modal-title, 18px);font-weight:700;line-height:1.5}.devui-font-size-page-title{font-size:16px;font-size:var(--devui-font-size-page-title, 16px)}.devui-font-page-title{font-size:16px;font-size:var(--devui-font-size-page-title, 16px);font-weight:700;line-height:1.5}.devui-font-size-secondary-title{font-size:14px;font-size:var(--devui-font-size-card-title, 14px)}.devui-font-secondary-title{font-size:14px;font-size:var(--devui-font-size-card-title, 14px);font-weight:700;line-height:1.5}.devui-category-search-container{position:relative;border-radius:2px;border-radius:var(--devui-border-radius, 2px);width:100%;height:32px;padding:0 8px;display:flex;align-items:flex-start;background:transparent;transition:border .3s cubic-bezier(.645,.045,.355,1);transition:border var(--devui-animation-duration-slow, .3s) var(--devui-animation-ease-in-out-smooth, cubic-bezier(.645, .045, .355, 1));background-color:#fff;background-color:var(--devui-base-bg, #ffffff);border:1px solid #d7d8da;border:1px solid var(--devui-line, #d7d8da)}.devui-category-search-container.container-hover{border:1px solid #9b9fa8;border:1px solid var(--devui-form-control-line-hover, #9b9fa8)}.devui-category-search-container.container-hover>.devui-category-search-icon svg g path{fill:#252b3a;fill:var(--devui-icon-fill-hover, #252b3a)}.devui-category-search-container>.devui-category-search-icon{margin-top:6px}.devui-category-search-container.devui-gray-style{background-color:#f5f5f5;background-color:var(--devui-gray-form-control-bg, #f5f5f5);border-color:transparent;transition:all .3s cubic-bezier(.645,.045,.355,1);transition:all var(--devui-animation-duration-slow, .3s) var(--devui-animation-ease-in-out-smooth, cubic-bezier(.645, .045, .355, 1))}.devui-category-search-container.devui-gray-style:hover{background-color:#ebebeb;background-color:var(--devui-gray-form-control-hover-bg, #ebebeb)}.devui-category-search-container.devui-gray-style:focus-within{background-color:#fff;background-color:var(--devui-base-bg, #ffffff);border-color:#5e7ce0;border-color:var(--devui-brand, #5e7ce0)}.devui-category-search-container.devui-gray-style .devui-category-search-input input.devui-category-search-toggle{background-color:transparent!important}.devui-category-search-container .devui-category-search-line-container{width:100%;height:32px;overflow:hidden}.devui-category-search-container .devui-category-search-line-container:hover{overflow-x:auto;overflow-x:overlay}.devui-category-search-container .devui-category-search-line-container .devui-category-search-line{display:flex;flex-flow:row nowrap;justify-content:flex-start;align-items:flex-start;width:100%;height:30px;position:relative;top:-1px}.devui-category-search-container .devui-category-search-line-container .devui-category-search-line>li{display:flex;align-items:center;flex-grow:0;white-space:nowrap;height:100%}.devui-category-search-container .devui-category-search-line-container .devui-category-search-line .devui-category-search-input{display:flex;justify-content:flex-start;flex-grow:1;align-items:center;min-width:160px;padding-right:20px}.devui-category-search-container .devui-category-search-line-container .devui-category-search-line .devui-category-search-input input{min-width:240px;width:100%;height:32px;font-size:12px;font-size:var(--devui-font-size-sm, 12px)}.devui-category-search-container .devui-category-search-line-container .devui-category-search-line .devui-category-search-input .devui-category-search-toggle{padding-left:0}.devui-category-search-container .devui-category-search-line-container .devui-category-search-line .devui-category-search-input .devui-category-search-keyword-in-category{overflow:visible}.devui-category-search-container input{border:none;background:transparent}.devui-category-search-container .devui-input-container{display:flex;flex:1}.devui-category-search-container .devui-category-search-extended-container{display:flex;flex-wrap:nowrap;width:-moz-fit-content;width:fit-content;height:16px;margin:8px 0;border-left:solid 1px #d7d8da;border-left:solid 1px var(--devui-line, #d7d8da);padding-left:8px}.devui-category-search-container .devui-category-search-extended-container:empty{border:none;padding-left:0}.devui-tag-item{display:inline-block;margin-right:4px}.devui-tag-item:first-child{margin-left:4px}.devui-tag-item:focus{outline:none}.devui-tag-item .devui-color-block-split-line{color:#71757f;color:var(--devui-aide-text, #71757f)}.devui-tag-item .devui-color-block-sm{width:8px;height:8px;border-radius:2px;border-radius:var(--devui-border-radius, 2px);margin-right:4px;display:inline-block;position:relative;top:-1px;vertical-align:middle}span:focus{outline:none}.devui-category-search-icon{display:flex;padding-right:8px;align-items:center;height:16px;cursor:pointer}.devui-category-search-icon svg g path{outline:none;fill:#71757f;fill:var(--devui-icon-fill, #71757f);transition:all cubic-bezier(.645,.045,.355,1) .3s;transition:all var(--devui-animation-ease-in-out-smooth, cubic-bezier(.645, .045, .355, 1)) var(--devui-animation-duration-slow, .3s)}.devui-category-search-icon.disabled{cursor:not-allowed}.devui-category-search-icon.disabled svg g path{fill:#cfd0d3;fill:var(--devui-disabled-text, #cfd0d3)}.devui-category-search-icon:not(.disabled):hover svg g path{fill:#252b3a;fill:var(--devui-icon-fill-hover, #252b3a)}input,input:focus{outline:none!important}a:focus,a:hover{color:#252b3a;color:var(--devui-list-item-hover-text, #252b3a)}d-tag{cursor:pointer}.devui-category-search-toggle{height:30px}.devui-date-picker-operation-area{border-top:1px solid #f2f2f3;border-top:1px solid var(--devui-dividing-line, #f2f2f3);margin:16px 0;padding:16px 16px 0;display:flex;justify-content:flex-end}.devui-date-picker-operation-area d-button:not(:first-child){margin-left:16px}.devui-dropdown-operation-area{border-top:1px solid #f2f2f3;border-top:1px solid var(--devui-dividing-line, #f2f2f3);padding-top:8px;margin:8px 0;display:flex;justify-content:center}.devui-dropdown-operation-area d-button:first-child{margin-right:8px}.devui-input-number-operation-area{padding:16px 16px 8px;display:flex;justify-content:space-evenly}.devui-save-panel{width:400px;height:auto;margin-top:4px}.devui-save-panel .devui-save-panel-title{display:flex;justify-content:space-between;height:48px;line-height:48px;border-bottom:1px solid #f2f2f3;border-bottom:1px solid var(--devui-dividing-line, #f2f2f3);padding:0 20px;font-size:14px;font-weight:700;color:16px;color:var(--devui-font-size-page-title, 16px)}.devui-save-panel .devui-save-filter-name{padding:16px 20px}.devui-save-panel .devui-save-filter-name>form{position:relative}.devui-save-panel .devui-save-filter-name>form svg{position:absolute;right:8px;top:50%;transform:translateY(-50%);cursor:pointer}.devui-save-panel .devui-save-filter-name>form svg path{fill:#71757f;fill:var(--devui-icon-fill, #71757f)}.devui-save-panel .devui-save-filter-name>form svg:hover svg g path{fill:#252b3a;fill:var(--devui-icon-fill-hover, #252b3a)}.devui-save-panel .devui-save-filter-name>span{padding-bottom:8px;display:block;line-height:1em}.devui-save-panel .devui-save-filter-name>input{width:100%;height:32px;margin:4px auto;line-height:20px;border:1px solid #d7d8da;border:1px solid var(--devui-form-control-line, #d7d8da)}.devui-save-panel .devui-save-panel-operation-area{padding-bottom:12px;display:flex;justify-content:center}.devui-save-panel .devui-save-panel-operation-area d-button:not(:first-child){margin-left:16px}.devui-dropdown-menu-template{max-width:300px;max-height:352px;overflow:auto}.devui-dropdown-menu-template .devui-category-search-group{font-size:12px;font-size:var(--devui-font-size, 12px)}.devui-dropdown-menu-template .devui-category-search-group.devui-dropdown-item:hover{background-color:transparent;color:#252b3a;color:var(--devui-text, #252b3a);cursor:default}.devui-selected-tags-list ul{display:flex;flex-flow:row wrap;align-items:center;justify-content:flex-start;padding:4px;max-height:390px;overflow:auto}.devui-selected-tags-list ul li{display:flex;flex-grow:0;flex-flow:row wrap}.devui-selected-tags-list ul li:first-child{margin-left:0}:host ::ng-deep .devui-tag-container{line-height:1}:host ::ng-deep .devui-tag-container d-tag>.devui-tag-item{display:block!important}:host ::ng-deep .devui-tag-container d-tag>.devui-tag-item>span{overflow:hidden;text-overflow:ellipsis;white-space:nowrap;display:inline-block;vertical-align:bottom;margin:0 4px}:host ::ng-deep .devui-checkbox-column-margin{height:32px!important;line-height:32px!important}::ng-deep .cdk-overlay-container d-datepicker[id=devui-category-search-date-picker] .devui-month-view{box-shadow:none!important}::ng-deep .cdk-overlay-container d-datepicker[id=devui-category-search-date-picker] .devui-month-view tfoot{display:none}::ng-deep .cdk-overlay-container .devui-selected-tags-list ul li .remove-button{right:8px}::ng-deep .cdk-overlay-container d-tag>.devui-tag-item{display:block!important}::ng-deep .cdk-overlay-container d-tag>.devui-tag-item>span{overflow:hidden;text-overflow:ellipsis;white-space:nowrap;display:inline-block;vertical-align:bottom;margin:0 4px}::ng-deep .devui-dropdown-top .devui-dropdown-menu-fix,::ng-deep .devui-dropdown-bottom .devui-dropdown-menu-fix,::ng-deep .devui-dropdown-open .devui-dropdown-menu-fix{margin-bottom:0}::ng-deep .devui-dropdown-menu-fix{min-width:200px;margin-left:0;overflow-y:auto;white-space:nowrap}::ng-deep .devui-dropdown-menu-fix.max-height{max-height:405px}::ng-deep .devui-dropdown-menu-fix .devui-checkbox-group{padding:8px 12px 0}::ng-deep .devui-dropdown-menu-fix .devui-checkbox-group .devui-color-block{width:12px;height:12px;margin-right:8px;border-radius:2px;border-radius:var(--devui-border-radius, 2px);top:-1px;position:relative;vertical-align:middle;display:inline-block}::ng-deep .devui-dropdown-menu-fix .devui-category-search-type-text-input{margin:16px 8px 8px;width:calc(100% - 16px)}::ng-deep .devui-dropdown-menu-fix .devui-select-list{display:flex;flex-wrap:wrap;max-width:300px;padding:8px}::ng-deep .devui-dropdown-menu-fix .devui-select-list span{margin-right:8px}::ng-deep .devui-dropdown-menu-fix .devui-search-container d-search{width:100%}::ng-deep .devui-dropdown-menu-fix .devui-search-container d-search .devui-search .devui-input.devui-clear-exit:not(.devui-icon-left){padding-right:28px}::ng-deep .devui-dropdown-menu-fix .devui-category-search-tree-container{overflow-y:auto;max-height:264px;padding:12px}::ng-deep .devui-dropdown-menu-fix .devui-no-data-tip{padding:12px}::ng-deep .devui-dropdown-menu-fix .devui-yearOption,::ng-deep .devui-dropdown-menu-fix .devui-monthOption{white-space:normal}::ng-deep .devui-dropdown-menu-fix d-datepicker-calendar{display:block}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox{margin:0 -8px;padding:0 8px}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox:hover{background-color:#f2f2f3;background-color:var(--devui-list-item-hover-bg, #f2f2f3)}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox:hover label{color:#252b3a;color:var(--devui-list-item-hover-text, #252b3a)}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox:active{background-color:#f2f5fc;background-color:var(--devui-list-item-active-bg, #f2f5fc)}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox:active label{color:#252b3a;color:var(--devui-list-item-active-text, #252b3a)}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox label{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;width:100%}::ng-deep .devui-dropdown-menu-fix d-input-number{width:70px}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group ul{max-height:310px}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox{transition:background-color .1s cubic-bezier(.645,.045,.355,1);transition:background-color var(--devui-animation-duration-fast, .1s) var(--devui-animation-ease-in-out-smooth, cubic-bezier(.645, .045, .355, 1))}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox label{transition:color .1s cubic-bezier(.645,.045,.355,1);transition:color var(--devui-animation-duration-fast, .1s) var(--devui-animation-ease-in-out-smooth, cubic-bezier(.645, .045, .355, 1))}.devui-dropdown-menu-tip{cursor:text;padding:12px 12px 0;pointer-events:none;color:#71757f;color:var(--devui-aide-text, #71757f)}.devui-dividing-line{height:1px;width:100%;background-color:#f2f2f3;background-color:var(--devui-dividing-line, #f2f2f3);margin-top:4px}.devui-dropdown-menu{margin-top:4px;padding-bottom:0}.devui-dropdown-menu .devui-dropdown-item .icon-search{margin-right:4px}.devui-no-data-text{padding:8px 0;text-align:center}.devui-datepicker-footer{text-align:center}\n"], dependencies: [{ kind: "directive", type: i3.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i3.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i3.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i3.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i3.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: i4.DFormControlRuleDirective, selector: "[dValidateRules][formControlName],[dValidateRules][ngModel],[dValidateRules][formControl]", inputs: ["dValidateRules", "dValidatePopConfig"], outputs: ["dRulesStatusChange"], exportAs: ["dValidateRules"] }, { kind: "directive", type: i5.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { kind: "directive", type: i5.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i5.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i5.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "directive", type: i5.MaxLengthValidator, selector: "[maxlength][formControlName],[maxlength][formControl],[maxlength][ngModel]", inputs: ["maxlength"] }, { kind: "directive", type: i5.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: i5.NgForm, selector: "form:not([ngNoForm]):not([formGroup]),ng-form,[ngForm]", inputs: ["ngFormOptions"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { kind: "directive", type: i6.DropDownDirective, selector: "[dDropDown]", inputs: ["isOpen", "disabled", "showAnimation", "trigger", "closeScope", "closeOnMouseLeaveMenu"], outputs: ["toggleEvent"], exportAs: ["d-dropdown"] }, { kind: "directive", type: i6.DropDownMenuDirective, selector: "[dDropDownMenu]", exportAs: ["d-dropdown-menu"] }, { kind: "directive", type: i6.DropDownToggleDirective, selector: "[dDropDownToggle]", inputs: ["toggleOnFocus", "autoFocus"], exportAs: ["d-dropdown-toggle"] }, { kind: "component", type: i6.DropDownAppendToBodyComponent, selector: "[dDropDown][appendToBody]", inputs: ["alignOrigin", "appendToBodyDirections", "appendToBodyScrollStrategy"] }, { kind: "directive", type: i7.TextDirective, selector: "[dTextInput]", inputs: ["error", "size", "styleType"], exportAs: ["dTextInput"] }, { kind: "component", type: i8.SearchComponent, selector: "d-search", inputs: ["size", "placeholder", "maxLength", "isKeyupSearch", "delay", "disabled", "cssClass", "iconPosition", "noBorder", "autoFocus", "styleType"], outputs: ["searchFn"], exportAs: ["search"] }, { kind: "component", type: i9.TagComponent, selector: "d-tag", inputs: ["tag", "labelStyle", "customColor", "deletable", "titleContent", "mode", "checked", "maxWidth", "customViewTemplate", "beforeDelete"], outputs: ["tagDelete", "checkedChange"], exportAs: ["Tag"] }, { kind: "component", type: i10.ButtonComponent, selector: "d-button", inputs: ["id", "type", "bsStyle", "shape", "bsSize", "bsPosition", "bordered", "icon", "disabled", "showLoading", "width", "autofocus", "loadingTemplateRef"], outputs: ["btnClick"] }, { kind: "component", type: i11.CheckBoxGroupComponent, selector: "d-checkbox-group", inputs: ["name", "itemWidth", "color", "direction", "isShowTitle", "disabled", "options", "filterKey", "labelTemplate", "showAnimation", "beforeChange"], outputs: ["change"] }, { kind: "component", type: i12.InputNumberComponent, selector: "d-input-number", inputs: ["step", "disabled", "size", "decimalLimit", "autoFocus", "allowEmpty", "placeholder", "maxLength", "reg", "styleType", "min", "max"], outputs: ["afterValueChanged", "whileValueChanging"] }, { kind: "component", type: i13.OperableTreeComponent, selector: "d-operable-tree", inputs: ["tree", "treeNodeIdKey", "treeNodeChildrenKey", "checkboxDisabledKey", "selectDisabledKey", "toggleDisabledKey", "iconParentOpen", "iconParentClose", "iconLeaf", "showLoading", "loadingTemplateRef", "treeNodesRef", "checkable", "deletable", "addable", "editable", "draggable", "disableMouseEvent", "checkboxInput", "beforeAddNode", "beforeDeleteNode", "beforeEditNode", "beforeSelectNode", "beforeNodeDrop", "canActivateNode", "canActivateParentNode", "canActivateMultipleNode", "treeNodeTitleKey", "postAddNode", "iconTemplatePosition", "virtualScroll", "virtualScrollHeight", "showAnimation", "itemSize", "minBufferPx", "maxBufferPx", "checkableRelation", "indent", "canIdEmpty", "dropType"], outputs: ["nodeSelected", "nodeDblClicked", "nodeRightClicked", "nodeToggled", "afterTreeInit", "nodeDeleted", "nodeChecked", "currentNodeChecked", "nodeEdited", "editValueChange", "nodeDragStart", "nodeOnDrop"], exportAs: ["dOperableTreeComponent"] }, { kind: "component", type: i14.DatepickerProCalendarComponent, selector: "d-datepicker-calendar", inputs: ["activeRangeType", "isRangeType", "showTime", "mode", "startIndexOfWeek", "splitter", "showRangeHeader", "placeholder", "allowClear", "minDate", "maxDate", "markedRangeDateList", "markedDateList"], outputs: ["confirmEvent", "cancelEvent"] }, { kind: "directive", type: DefaultTemplateDirective, selector: "ng-template[type]", inputs: ["type"] }] });
__decorate([
    WithConfig(),
    __metadata("design:type", Object)
], CategorySearchComponent.prototype, "styleType", void 0);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: CategorySearchComponent, decorators: [{
            type: Component,
            args: [{ selector: 'd-category-search', template: "<div\n  #PrimeContainer\n  class=\"devui-category-search-container devui-category-search-id-{{ id }}\"\n  [ngClass]=\"{ 'container-hover': isHover && !isFocus, 'devui-gray-style': styleType === 'gray' }\"\n  (mouseenter)=\"isHover = true\"\n  (mouseleave)=\"isHover = false\"\n>\n  <div class=\"devui-category-search-icon\" (click)=\"search()\">\n    <svg width=\"16px\" height=\"16px\" viewBox=\"0 0 16 16\" class=\"svg-icon-search\">\n      <g stroke=\"none\" stroke-width=\"1\" fill=\"none\" fill-rule=\"evenodd\">\n        <path\n          d=\"M7,0 C10.8659932,0 14,3.13400675 14,7 C14,8.57190212 13.4818819,10.0227913 12.6071076,11.1912056 L15.7071068,14.2928932 C16.0976311,14.6834175 16.0976311,15.3165825 15.7071068,15.7071068 C15.3466228,16.0675907 14.7793918,16.0953203 14.3871006,15.7902954 L14.2928932,15.7071068 L11.1912056,12.6071076 C10.0227913,13.4818819 8.57190212,14 7,14 C3.13400675,14 5.5067062e-14,10.8659932 5.5067062e-14,7 C5.5067062e-14,3.13400675 3.13400675,0 7,0 Z M7,2 C4.23857625,2 2,4.23857625 2,7 C2,9.76142375 4.23857625,12 7,12 C9.76142375,12 12,9.76142375 12,7 C12,4.23857625 9.76142375,2 7,2 Z\"\n          fill=\"#71757F\"\n        ></path>\n      </g>\n    </svg>\n  </div>\n  <div #ScrollBarContainer class=\"devui-category-search-line-container\">\n    <ul class=\"devui-category-search-line\">\n      <li\n        class=\"devui-tag-item\"\n        *ngFor=\"let item of selectedTags\"\n        #selectedDropdown=\"d-dropdown\"\n        [ngStyle]=\"{ width: tagMaxWidth || '' }\"\n        dDropDown\n        appendToBody\n        dDropDownToggle\n        [appendToBodyDirections]=\"['rightDown', 'rightUp', 'leftDown', 'leftUp']\"\n        [closeScope]=\"checkType(item)\"\n        (toggleEvent)=\"resetContent(selectedDropdown, item)\"\n      >\n        <ng-template\n          [ngTemplateOutlet]=\"joinLabelTypesTemplate\"\n          [ngTemplateOutletContext]=\"{ item: item, isJoinLabelType: joinLabelTypes.includes(item.type) }\"\n        ></ng-template>\n        <div dDropDownMenu class=\"devui-dropdown-menu devui-dropdown-menu-fix\" [ngClass]=\"{ 'max-height': item.type !== 'treeSelect' }\">\n          <ng-template\n            [ngTemplateOutlet]=\"item.customTemplate || templates[item.type]\"\n            [ngTemplateOutletContext]=\"{ tagOption: item, dropdown: selectedDropdown, isSelected: true }\"\n          ></ng-template>\n        </div>\n      </li>\n      <div class=\"devui-category-search-input\">\n        <div\n          class=\"devui-input-container\"\n          #inputDropdown=\"d-dropdown\"\n          dDropDown\n          appendToBody\n          [trigger]=\"'manually'\"\n          [appendToBodyDirections]=\"['rightDown', 'rightUp', 'leftDown', 'leftUp']\"\n          [closeScope]=\"checkType(currentSelectTag)\"\n          (toggleEvent)=\"resetContent(inputDropdown)\"\n        >\n          <div style=\"width: 100%\">\n            <input\n              class=\"devui-category-search-toggle\"\n              autocomplete=\"off\"\n              #InputEle\n              dDropDownToggle\n              [readOnly]=\"inputReadOnly\"\n              [placeholder]=\"placeholderText || i18nCategorySearchText?.searchPlaceholder || ''\"\n              [ngModel]=\"searchKey\"\n              (ngModelChange)=\"searchKeyChangeEvent($event)\"\n              (click)=\"openMenu(inputDropdown, $event)\"\n              (keyup)=\"checkInputSearching(); openMenu(inputDropdown, $event)\"\n              (keydown.backspace)=\"backspaceEvent(inputDropdown)\"\n              (keydown.enter)=\"searchInputValue($event); closeMenu(inputDropdown)\"\n              (focus)=\"isHover = false; isFocus = true\"\n              (blur)=\"isFocus = false; blurInput($event)\"\n            />\n          </div>\n          <div\n            *ngIf=\"!enterSearch || (enterSearch && showSearchCategory)\"\n            dDropDownMenu\n            class=\"devui-dropdown-menu devui-dropdown-menu-fix devui-scrollbar devui-category-dropdown-menu-{{ id }}\"\n            [ngClass]=\"{ 'max-height': currentSelectTag?.type !== 'treeSelect' }\"\n          >\n            <ul *ngIf=\"!currentSelectTag\" class=\"devui-dropdown-menu-template\">\n              <ng-container *ngIf=\"!enterSearch && !currentSelectTag\">\n                <ng-container *ngFor=\"let item of categoryDisplay\">\n                  <li *ngIf=\"item.groupLength\" class=\"devui-dropdown-item devui-category-search-group\">\n                    <ng-template\n                      [ngTemplateOutlet]=\"customGroupNameTemplate || defaultGroupNameTemplate\"\n                      [ngTemplateOutletContext]=\"{ tag: item }\"\n                    ></ng-template>\n                  </li>\n                  <li\n                    *ngIf=\"item.groupLength === undefined\"\n                    class=\"devui-dropdown-item\"\n                    (click)=\"chooseCategory(item, inputDropdown); closeMenu(inputDropdown)\"\n                  >\n                    <span title=\"{{ item?.label }}\">{{ item?.label }}</span>\n                  </li>\n                </ng-container>\n                <div class=\"devui-no-data-text\" *ngIf=\"showNoDataTips\">{{ i18nCategorySearchText?.noFilterConditions }}</div>\n              </ng-container>\n              <ng-container *ngIf=\"enterSearch\">\n                <li\n                  *ngIf=\"showSearchConfig.keyword\"\n                  class=\"devui-dropdown-item devui-search-description\"\n                  (click)=\"searchInputValue($event); closeMenu(inputDropdown)\"\n                >\n                  <span class=\"icon-search\"></span>{{ showSearchConfig.keywordDescription(searchKey) }}\n                </li>\n                <ng-container *ngIf=\"showSearchConfig.field\">\n                  <li *ngFor=\"let item of searchField\" (click)=\"searchCategory(item); closeMenu(inputDropdown)\" class=\"devui-dropdown-item\">\n                    <span class=\"icon-search\"></span>{{ showSearchConfig.fieldDescription(item?.label) }}\n                  </li>\n                </ng-container>\n                <div\n                  *ngIf=\"(showSearchConfig.keyword || showSearchConfig.field) && showSearchConfig.category && currentSearchCategory?.length\"\n                  class=\"devui-dividing-line\"\n                ></div>\n                <ng-container *ngIf=\"showSearchConfig.category && currentSearchCategory?.length\">\n                  <div class=\"devui-dropdown-menu-tip\" [style.paddingBottom]=\"currentSearchCategory.length ? '0' : '12px'\">\n                    {{ showSearchConfig.categoryDescription }}\n                  </div>\n                  <ul class=\"devui-category-search-keyword-in-category devui-dropdown-menu-template\">\n                    <li\n                      *ngFor=\"let item of currentSearchCategory\"\n                      (click)=\"showCurrentSearchCategory(item, inputDropdown)\"\n                      class=\"devui-dropdown-item\"\n                    >\n                      <span>{{ item?.label }}</span>\n                    </li>\n                  </ul>\n                </ng-container>\n              </ng-container>\n            </ul>\n            <ng-container *ngIf=\"!enterSearch && currentSelectTag\">\n              <ng-template\n                [ngTemplateOutlet]=\"currentSelectTag.customTemplate || templates[currentSelectTag.type]\"\n                [ngTemplateOutletContext]=\"{ tagOption: currentSelectTag, dropdown: inputDropdown }\"\n              ></ng-template>\n            </ng-container>\n          </div>\n        </div>\n      </div>\n    </ul>\n  </div>\n  <div class=\"devui-category-search-extended-container\" *ngIf=\"showExtendedConfig\">\n    <ng-template *ngIf=\"_extendedConfig.clear.show\" [ngTemplateOutlet]=\"_extendedConfig.clear.template || clearTpl\"></ng-template>\n    <ng-template *ngIf=\"_extendedConfig.save.show\" [ngTemplateOutlet]=\"_extendedConfig.save.template || saveTpl\"></ng-template>\n    <ng-template *ngIf=\"_extendedConfig.more.show\" [ngTemplateOutlet]=\"_extendedConfig.more.template || moreTpl\"></ng-template>\n    <ng-template *ngIf=\"_extendedConfig.customTemplate\" [ngTemplateOutlet]=\"_extendedConfig.customTemplate\"></ng-template>\n  </div>\n</div>\n\n<ng-template #defaultGroupNameTemplate let-item=\"tag\">\n  <strong>{{ item?.groupName }}</strong>\n</ng-template>\n\n<ng-template #noData>\n  <div class=\"devui-no-data-tip\">{{ i18nCommonText?.noData }}</div>\n</ng-template>\n\n<ng-template #clearTpl>\n  <div\n    class=\"devui-category-search-icon\"\n    [class.disabled]=\"_extendedConfig.clear.disabled\"\n    (click)=\"!_extendedConfig.clear.disabled && clearFilter($event)\"\n  >\n    <svg width=\"16px\" height=\"16px\" viewBox=\"0 0 16 16\">\n      <title>{{ i18nCategorySearchText?.clearFilterCondition }}</title>\n      <g stroke=\"none\" stroke-width=\"1\" fill=\"none\" fill-rule=\"evenodd\">\n        <path\n          d=\"M4.61289944,3.20970461 L4.70710678,3.29289322 L8,6.585 L11.2928932,3.29289322 C11.6834175,2.90236893 12.3165825,2.90236893 12.7071068,3.29289322 C13.0675907,3.65337718 13.0953203,4.22060824 12.7902954,4.61289944 L12.7071068,4.70710678 L9.415,8 L12.7071068,11.2928932 C13.0976311,11.6834175 13.0976311,12.3165825 12.7071068,12.7071068 C12.3466228,13.0675907 11.7793918,13.0953203 11.3871006,12.7902954 L11.2928932,12.7071068 L8,9.415 L4.70710678,12.7071068 C4.31658249,13.0976311 3.68341751,13.0976311 3.29289322,12.7071068 C2.93240926,12.3466228 2.90467972,11.7793918 3.20970461,11.3871006 L3.29289322,11.2928932 L6.585,8 L3.29289322,4.70710678 C2.90236893,4.31658249 2.90236893,3.68341751 3.29289322,3.29289322 C3.65337718,2.93240926 4.22060824,2.90467972 4.61289944,3.20970461 Z\"\n          fill-rule=\"nonzero\"\n        ></path>\n      </g>\n    </svg>\n  </div>\n</ng-template>\n\n<ng-template #saveTpl>\n  <div\n    class=\"devui-category-search-icon\"\n    #saveDropdown=\"d-dropdown\"\n    dDropDown\n    appendToBody\n    [appendToBodyDirections]=\"['rightDown', 'rightUp', 'leftDown', 'leftUp']\"\n    [class.disabled]=\"_extendedConfig.save.disabled\"\n    [closeScope]=\"'blank'\"\n    [disabled]=\"_extendedConfig.save.disabled\"\n    (toggleEvent)=\"createFilterInputAutoFocus(saveDropdown, createFilterInput, filterNameForm)\"\n  >\n    <svg width=\"16px\" height=\"16px\" viewBox=\"0 0 16 16\" version=\"1.1\" dDropDownToggle>\n      <title>{{ textConfig.createFilter }}</title>\n      <g stroke=\"none\" stroke-width=\"1\" fill=\"none\" fill-rule=\"evenodd\">\n        <path\n          d=\"M12,1 L15,4 L15,13 C15,14.1045695 14.1045695,15 13,15 L3,15 C1.8954305,15 1,14.1045695 1,13 L1,3 C1,1.8954305 1.8954305,1 3,1 L12,1 Z M11.171,3 L3,3 L3,13 L4,13 L4,10 C4,9.48716416 4.38604019,9.06449284 4.88337887,9.00672773 L5,9 L11,9 C11.5128358,9 11.9355072,9.38604019 11.9932723,9.88337887 L12,10 L12,13 L13,13 L13,4.829 L11.171,3 Z M9.999,10.999 L5.999,10.999 L6,13 L10,13 L9.999,10.999 Z M7,5 C7.55228475,5 8,5.44771525 8,6 C8,6.55228475 7.55228475,7 7,7 L5,7 C4.44771525,7 4,6.55228475 4,6 C4,5.44771525 4.44771525,5 5,5 L7,5 Z\"\n          fill-rule=\"nonzero\"\n        ></path>\n      </g>\n    </svg>\n    <div dDropDownMenu class=\"devui-save-panel\">\n      <div class=\"devui-save-panel-title\">\n        <span>{{ textConfig.createFilter }}</span>\n      </div>\n      <div class=\"devui-save-filter-name\">\n        <span>{{ textConfig.filterTitle }}</span>\n        <form #filterNameForm=\"ngForm\">\n          <input\n            name=\"filter-name\"\n            class=\"devui-category-search-toggle\"\n            autocomplete=\"off\"\n            #createFilterInput\n            dTextInput\n            [(ngModel)]=\"filterName\"\n            [placeholder]=\"i18nCategorySearchText?.placeholder || ''\"\n            [dValidateRules]=\"filterNameRules\"\n          />\n          <svg\n            *ngIf=\"showFilterNameClear\"\n            (click)=\"$event.preventDefault(); $event.stopPropagation(); filterName = ''\"\n            width=\"16px\"\n            height=\"16px\"\n            viewBox=\"0 0 16 16\"\n          >\n            <title>{{ i18nCategorySearchText?.clearFilterCondition }}</title>\n            <g stroke=\"none\" stroke-width=\"1\" fill=\"none\" fill-rule=\"evenodd\">\n              <path\n                d=\"M4.61289944,3.20970461 L4.70710678,3.29289322 L8,6.585 L11.2928932,3.29289322 C11.6834175,2.90236893 12.3165825,2.90236893 12.7071068,3.29289322 C13.0675907,3.65337718 13.0953203,4.22060824 12.7902954,4.61289944 L12.7071068,4.70710678 L9.415,8 L12.7071068,11.2928932 C13.0976311,11.6834175 13.0976311,12.3165825 12.7071068,12.7071068 C12.3466228,13.0675907 11.7793918,13.0953203 11.3871006,12.7902954 L11.2928932,12.7071068 L8,9.415 L4.70710678,12.7071068 C4.31658249,13.0976311 3.68341751,13.0976311 3.29289322,12.7071068 C2.93240926,12.3466228 2.90467972,11.7793918 3.20970461,11.3871006 L3.29289322,11.2928932 L6.585,8 L3.29289322,4.70710678 C2.90236893,4.31658249 2.90236893,3.68341751 3.29289322,3.29289322 C3.65337718,2.93240926 4.22060824,2.90467972 4.61289944,3.20970461 Z\"\n                fill-rule=\"nonzero\"\n              ></path>\n            </g>\n          </svg>\n        </form>\n      </div>\n      <div class=\"devui-save-panel-operation-area\">\n        <d-button [disabled]=\"filterNameForm.invalid\" (btnClick)=\"createFilterFn(); saveDropdown.toggle()\">{{\n          i18nCategorySearchText?.confirm\n        }}</d-button>\n        <d-button bsStyle=\"common\" (btnClick)=\"saveDropdown.toggle()\">{{ i18nCategorySearchText?.cancel }}</d-button>\n      </div>\n    </div>\n  </div>\n</ng-template>\n\n<ng-template #moreTpl>\n  <div\n    class=\"devui-category-search-icon\"\n    #seeMoreDropdown=\"d-dropdown\"\n    dDropDown\n    appendToBody\n    [alignOrigin]=\"primeContainer\"\n    [appendToBodyDirections]=\"['rightDown', 'rightUp', 'leftDown', 'leftUp']\"\n    [class.disabled]=\"_extendedConfig.more.disabled\"\n  >\n    <svg width=\"16px\" height=\"16px\" viewBox=\"0 0 16 16\" dDropDownToggle>\n      <title>{{ i18nCategorySearchText?.seeMore }}</title>\n      <g stroke=\"none\" stroke-width=\"1\" fill=\"none\" fill-rule=\"evenodd\">\n        <path\n          d=\"M1,2 L3,2 L3,4 L1,4 L1,2 Z M1,7 L3,7 L3,9 L1,9 L1,7 Z M1,12 L3,12 L3,14 L1,14 L1,12 Z M5,2 L15,2 L15,4 L5,4 L5,2 Z M5,7 L15,7 L15,9 L5,9 L5,7 Z M5,12 L15,12 L15,14 L5,14 L5,12 Z\"\n          fill-rule=\"nonzero\"\n        ></path>\n      </g>\n    </svg>\n    <div dDropDownMenu class=\"devui-selected-tags-list\">\n      <ul [ngStyle]=\"{ width: PrimeContainer?.clientWidth + 'px' }\">\n        <li class=\"devui-tag-item\" *ngFor=\"let item of selectedTags; let i = index\" (click)=\"scrollToTag(i, $event)\">\n          <ng-template\n            [ngTemplateOutlet]=\"joinLabelTypesTemplate\"\n            [ngTemplateOutletContext]=\"{ item: item, isJoinLabelType: joinLabelTypes.includes(item.type) }\"\n          ></ng-template>\n        </li>\n      </ul>\n    </div>\n  </div>\n</ng-template>\n\n<ng-template #joinLabelTypesTemplate let-item=\"item\" let-isJoinLabelType=\"isJoinLabelType\">\n  <div class=\"devui-tag-container\">\n    <d-tag\n      [deletable]=\"true\"\n      [tag]=\"isJoinLabelType ? item : item.label + ': ' + (item.value[item.filterKey || 'label'] || '')\"\n      [titleContent]=\"item.title\"\n      [customViewTemplate]=\"item.tagCustomTemplate || (isJoinLabelType && defaultTagContentTemplate)\"\n      (tagDelete)=\"removeTag(item, $event.event)\"\n    ></d-tag>\n  </div>\n</ng-template>\n\n<ng-template #defaultTagContentTemplate let-tag=\"tag\" let-colorKey=\"tag.colorKey || 'color'\">\n  <span>{{ tag.label }}: </span>\n  <ng-container *ngFor=\"let val of tag.value.cache; let i = index\">\n    <span *ngIf=\"i > 0\" class=\"devui-color-block-split-line\">{{ textConfig.labelConnector || '|' }}</span>\n    <span *ngIf=\"tag.type === 'label'\" class=\"devui-color-block-sm\" [style.background]=\"val[colorKey]\"></span>\n    <span [style.color]=\"val[colorKey]\">{{ val[tag.filterKey || 'label'] || '' }}</span>\n  </ng-container>\n</ng-template>\n\n<ng-template [type]=\"'radio'\" let-tagOption=\"tagOption\" let-key=\"tagOption.filterKey || 'label'\">\n  <div *ngIf=\"!tagOption.options?.length\">\n    <ng-container *ngTemplateOutlet=\"noData\"></ng-container>\n  </div>\n  <ul *ngIf=\"tagOption.options?.length\" class=\"devui-dropdown-menu-template devui-scrollbar\">\n    <li\n      *ngFor=\"let item of tagOption.options\"\n      title=\"{{ item[key] }}\"\n      class=\"devui-dropdown-item\"\n      [class.active]=\"tagOption?.value[key] === item[key]\"\n      (click)=\"chooseItem(tagOption, item)\"\n    >\n      <span>{{ item[key] }}</span>\n    </li>\n  </ul>\n</ng-template>\n\n<ng-template [type]=\"'dateRange'\" let-tagOption=\"tagOption\" let-dropdown=\"dropdown\">\n  <d-datepicker-calendar\n    #datepickerCalendarItem\n    *ngIf=\"dropdown.isOpen\"\n    id=\"{{ tagOption.field }}\"\n    style=\"overflow-x: hidden\"\n    #dDatepickerPro\n    [isRangeType]=\"true\"\n    [showTime]=\"tagOption.showTime\"\n    [activeRangeType]=\"tagOption.activeRangeType || 'start'\"\n    [(ngModel)]=\"tagOption.value.value\"\n  >\n    <ng-template #footerTemplate>\n      <div class=\"devui-datepicker-footer\">\n        <d-button\n          style=\"margin-right: 8px\"\n          bsStyle=\"primary\"\n          (btnClick)=\"confirmDate(datepickerCalendarItem, tagOption, dropdown)\"\n          [disabled]=\"\n            tagOption.showTime ? false : !tagOption.value.value || tagOption.value.value.length < 2 || tagOption.value.value.includes(null)\n          \"\n        >\n          {{ i18nCategorySearchText?.confirm }}\n        </d-button>\n        <d-button bsStyle=\"common\" (btnClick)=\"closeMenu(dropdown)\">{{ i18nCategorySearchText?.cancel }}</d-button>\n      </div>\n    </ng-template>\n  </d-datepicker-calendar>\n</ng-template>\n\n<ng-template [type]=\"'checkbox'\" let-tagOption=\"tagOption\" let-dropdown=\"dropdown\">\n  <div *ngIf=\"!tagOption.options?.length\">\n    <ng-container *ngTemplateOutlet=\"noData\"></ng-container>\n  </div>\n  <div *ngIf=\"tagOption.options?.length\" class=\"devui-dropdown-menu-template\">\n    <d-checkbox-group\n      [(ngModel)]=\"tagOption.value.value\"\n      [options]=\"tagOption.options\"\n      [filterKey]=\"tagOption.filterKey || 'label'\"\n      [isShowTitle]=\"true\"\n    >\n    </d-checkbox-group>\n  </div>\n  <div class=\"devui-dropdown-operation-area\">\n    <d-button (btnClick)=\"chooseItems(tagOption); closeMenu(dropdown)\">{{ i18nCategorySearchText?.confirm }}</d-button>\n    <d-button bsStyle=\"common\" (btnClick)=\"closeMenu(dropdown)\">{{ i18nCategorySearchText?.cancel }}</d-button>\n  </div>\n</ng-template>\n\n<ng-template [type]=\"'label'\" let-tagOption=\"tagOption\" let-dropdown=\"dropdown\">\n  <div *ngIf=\"!tagOption.options?.length\">\n    <ng-container *ngTemplateOutlet=\"noData\"></ng-container>\n  </div>\n  <div *ngIf=\"tagOption.options?.length\" class=\"devui-dropdown-menu-template\">\n    <d-checkbox-group\n      [(ngModel)]=\"tagOption.value.value\"\n      [options]=\"tagOption.options\"\n      [filterKey]=\"'$label'\"\n      [labelTemplate]=\"labelContent\"\n      [isShowTitle]=\"true\"\n    >\n      <ng-template #labelContent let-label=\"label\">\n        <span class=\"devui-color-block\" [style.background]=\"splitLabel('color', label)\" title=\"{{ splitLabel('label', label) }}\"></span>\n        <span title=\"{{ splitLabel('label', label) }}\">{{ splitLabel('label', label) }}</span>\n      </ng-template>\n    </d-checkbox-group>\n  </div>\n  <div class=\"devui-dropdown-operation-area\">\n    <d-button (btnClick)=\"chooseItems(tagOption); closeMenu(dropdown)\">{{ i18nCategorySearchText?.confirm }}</d-button>\n    <d-button bsStyle=\"common\" (btnClick)=\"closeMenu(dropdown)\">{{ i18nCategorySearchText?.cancel }}</d-button>\n  </div>\n</ng-template>\n\n<ng-template [type]=\"'textInput'\" let-tagOption=\"tagOption\" let-dropdown=\"dropdown\">\n  <form #textInputForm=\"ngForm\">\n    <input\n      name=\"text-input\"\n      class=\"devui-category-search-type-text-input\"\n      autocomplete=\"off\"\n      dTextInput\n      [(ngModel)]=\"tagOption.value.value\"\n      [maxlength]=\"tagOption.maxLength\"\n      [placeholder]=\"tagOption.placeholder || ''\"\n      [dValidateRules]=\"tagOption.validateRules\"\n    />\n  </form>\n  <div class=\"devui-dropdown-operation-area\">\n    <d-button [disabled]=\"textInputForm.invalid\" (btnClick)=\"getTextInputValue(tagOption); closeMenu(dropdown)\">{{\n      i18nCategorySearchText?.confirm\n    }}</d-button>\n    <d-button bsStyle=\"common\" (btnClick)=\"closeMenu(dropdown)\">{{ i18nCategorySearchText?.cancel }}</d-button>\n  </div>\n</ng-template>\n\n<ng-template [type]=\"'numberRange'\" let-tagOption=\"tagOption\" let-dropdown=\"dropdown\">\n  <div class=\"devui-input-number-operation-area\">\n    <d-input-number\n      size=\"sm\"\n      [min]=\"tagOption.min?.left\"\n      [max]=\"tagOption.max?.left\"\n      [maxLength]=\"tagOption.maxLength?.left\"\n      [step]=\"tagOption.step?.left || 1\"\n      [reg]=\"tagOption.reg?.left\"\n      [placeholder]=\"tagOption.placeholder?.left || ''\"\n      [(ngModel)]=\"tagOption.value.value[0]\"\n    >\n    </d-input-number>\n    <span> - </span>\n    <d-input-number\n      size=\"sm\"\n      [min]=\"tagOption.min?.right\"\n      [max]=\"tagOption.max?.right\"\n      [maxLength]=\"tagOption.maxLength?.right\"\n      [step]=\"tagOption.step?.right || 1\"\n      [reg]=\"tagOption.reg?.right\"\n      [placeholder]=\"tagOption.placeholder?.right || ''\"\n      [(ngModel)]=\"tagOption.value.value[1]\"\n    >\n    </d-input-number>\n  </div>\n  <div class=\"devui-dropdown-operation-area\">\n    <d-button (btnClick)=\"getNumberRangeValue(tagOption); closeMenu(dropdown)\">{{ i18nCategorySearchText?.confirm }}</d-button>\n    <d-button bsStyle=\"common\" (btnClick)=\"closeMenu(dropdown)\">{{ i18nCategorySearchText?.cancel }}</d-button>\n  </div>\n</ng-template>\n\n<ng-template [type]=\"'treeSelect'\" let-tagOption=\"tagOption\" let-dropdown=\"dropdown\" let-isSelected=\"isSelected\">\n  <div *ngIf=\"tagOption.multiple && tagOption.options?.length && tagOption.value.value?.length\">\n    <ul class=\"devui-select-list\">\n      <span>{{ i18nCategorySearchText?.selected }}</span>\n      <li class=\"devui-select-item devui-no-label-item\" *ngFor=\"let item of tagOption.value.value; last as isLast\">\n        {{ item[tagOption.filterKey || tagOption.treeNodeTitleKey || 'title'] }}\n        <span *ngIf=\"!isLast\">, </span>\n      </li>\n    </ul>\n  </div>\n  <div *ngIf=\"tagOption.searchable\" class=\"devui-search-container\">\n    <d-search\n      [placeholder]=\"tagOption.searchPlaceholder\"\n      [ngModel]=\"treeSearchKey\"\n      (ngModelChange)=\"treeSearch($event, tagOption.searchFn)\"\n    ></d-search>\n  </div>\n  <div class=\"devui-category-search-tree-container\" [style.display]=\"tagOption.options?.length && !treeNoRecord ? 'block' : 'none'\">\n    <d-operable-tree\n      #OperableTree\n      *ngIf=\"dropdown.isOpen || treeResetFlag\"\n      class=\"devui-tree\"\n      [tree]=\"isSelected ? tagOption.value.options : tagOption.options\"\n      [treeNodeIdKey]=\"tagOption.treeNodeIdKey || 'id'\"\n      [treeNodeChildrenKey]=\"tagOption.treeNodeChildrenKey || 'children'\"\n      [treeNodeTitleKey]=\"tagOption.filterKey || tagOption.treeNodeTitleKey || 'title'\"\n      [checkboxDisabledKey]=\"tagOption.disabledKey || 'disabled'\"\n      [checkable]=\"tagOption.multiple\"\n      [canActivateNode]=\"!tagOption.multiple\"\n      [canActivateParentNode]=\"!tagOption.leafOnly\"\n      [iconParentOpen]=\"tagOption.iconParentOpen || icons.iconParentOpen\"\n      [iconParentClose]=\"tagOption.iconParentClose || icons.iconParentClose\"\n      [iconLeaf]=\"tagOption.iconLeaf || icons.iconLeaf\"\n      (nodeChecked)=\"onOperableNodeChecked($event, tagOption)\"\n      (nodeSelected)=\"onOperableNodeSelected($event, tagOption); closeMenu(dropdown)\"\n    >\n    </d-operable-tree>\n  </div>\n  <div *ngIf=\"!tagOption.options?.length\">\n    <ng-container *ngTemplateOutlet=\"noData\"></ng-container>\n  </div>\n  <div *ngIf=\"treeNoRecord\" class=\"devui-no-data-tip\">{{ i18nCommonText?.noRecordsFound }}</div>\n  <div *ngIf=\"tagOption.multiple\" class=\"devui-dropdown-operation-area\">\n    <d-button [disabled]=\"!tagOption.value.value?.length\" (btnClick)=\"getTreeValue(tagOption); closeMenu(dropdown)\">{{\n      i18nCategorySearchText?.confirm\n    }}</d-button>\n    <d-button bsStyle=\"common\" (btnClick)=\"closeMenu(dropdown)\">{{ i18nCategorySearchText?.cancel }}</d-button>\n  </div>\n</ng-template>\n", styles: [".devui-font-size-base{font-size:12px;font-size:var(--devui-font-size, 12px)}.devui-font-base{font-size:12px;font-size:var(--devui-font-size, 12px);font-weight:400;line-height:1.5}.devui-font-size-modal-title{font-size:18px;font-size:var(--devui-font-size-modal-title, 18px)}.devui-font-modal-title{font-size:18px;font-size:var(--devui-font-size-modal-title, 18px);font-weight:700;line-height:1.5}.devui-font-size-page-title{font-size:16px;font-size:var(--devui-font-size-page-title, 16px)}.devui-font-page-title{font-size:16px;font-size:var(--devui-font-size-page-title, 16px);font-weight:700;line-height:1.5}.devui-font-size-secondary-title{font-size:14px;font-size:var(--devui-font-size-card-title, 14px)}.devui-font-secondary-title{font-size:14px;font-size:var(--devui-font-size-card-title, 14px);font-weight:700;line-height:1.5}.devui-category-search-container{position:relative;border-radius:2px;border-radius:var(--devui-border-radius, 2px);width:100%;height:32px;padding:0 8px;display:flex;align-items:flex-start;background:transparent;transition:border .3s cubic-bezier(.645,.045,.355,1);transition:border var(--devui-animation-duration-slow, .3s) var(--devui-animation-ease-in-out-smooth, cubic-bezier(.645, .045, .355, 1));background-color:#fff;background-color:var(--devui-base-bg, #ffffff);border:1px solid #d7d8da;border:1px solid var(--devui-line, #d7d8da)}.devui-category-search-container.container-hover{border:1px solid #9b9fa8;border:1px solid var(--devui-form-control-line-hover, #9b9fa8)}.devui-category-search-container.container-hover>.devui-category-search-icon svg g path{fill:#252b3a;fill:var(--devui-icon-fill-hover, #252b3a)}.devui-category-search-container>.devui-category-search-icon{margin-top:6px}.devui-category-search-container.devui-gray-style{background-color:#f5f5f5;background-color:var(--devui-gray-form-control-bg, #f5f5f5);border-color:transparent;transition:all .3s cubic-bezier(.645,.045,.355,1);transition:all var(--devui-animation-duration-slow, .3s) var(--devui-animation-ease-in-out-smooth, cubic-bezier(.645, .045, .355, 1))}.devui-category-search-container.devui-gray-style:hover{background-color:#ebebeb;background-color:var(--devui-gray-form-control-hover-bg, #ebebeb)}.devui-category-search-container.devui-gray-style:focus-within{background-color:#fff;background-color:var(--devui-base-bg, #ffffff);border-color:#5e7ce0;border-color:var(--devui-brand, #5e7ce0)}.devui-category-search-container.devui-gray-style .devui-category-search-input input.devui-category-search-toggle{background-color:transparent!important}.devui-category-search-container .devui-category-search-line-container{width:100%;height:32px;overflow:hidden}.devui-category-search-container .devui-category-search-line-container:hover{overflow-x:auto;overflow-x:overlay}.devui-category-search-container .devui-category-search-line-container .devui-category-search-line{display:flex;flex-flow:row nowrap;justify-content:flex-start;align-items:flex-start;width:100%;height:30px;position:relative;top:-1px}.devui-category-search-container .devui-category-search-line-container .devui-category-search-line>li{display:flex;align-items:center;flex-grow:0;white-space:nowrap;height:100%}.devui-category-search-container .devui-category-search-line-container .devui-category-search-line .devui-category-search-input{display:flex;justify-content:flex-start;flex-grow:1;align-items:center;min-width:160px;padding-right:20px}.devui-category-search-container .devui-category-search-line-container .devui-category-search-line .devui-category-search-input input{min-width:240px;width:100%;height:32px;font-size:12px;font-size:var(--devui-font-size-sm, 12px)}.devui-category-search-container .devui-category-search-line-container .devui-category-search-line .devui-category-search-input .devui-category-search-toggle{padding-left:0}.devui-category-search-container .devui-category-search-line-container .devui-category-search-line .devui-category-search-input .devui-category-search-keyword-in-category{overflow:visible}.devui-category-search-container input{border:none;background:transparent}.devui-category-search-container .devui-input-container{display:flex;flex:1}.devui-category-search-container .devui-category-search-extended-container{display:flex;flex-wrap:nowrap;width:-moz-fit-content;width:fit-content;height:16px;margin:8px 0;border-left:solid 1px #d7d8da;border-left:solid 1px var(--devui-line, #d7d8da);padding-left:8px}.devui-category-search-container .devui-category-search-extended-container:empty{border:none;padding-left:0}.devui-tag-item{display:inline-block;margin-right:4px}.devui-tag-item:first-child{margin-left:4px}.devui-tag-item:focus{outline:none}.devui-tag-item .devui-color-block-split-line{color:#71757f;color:var(--devui-aide-text, #71757f)}.devui-tag-item .devui-color-block-sm{width:8px;height:8px;border-radius:2px;border-radius:var(--devui-border-radius, 2px);margin-right:4px;display:inline-block;position:relative;top:-1px;vertical-align:middle}span:focus{outline:none}.devui-category-search-icon{display:flex;padding-right:8px;align-items:center;height:16px;cursor:pointer}.devui-category-search-icon svg g path{outline:none;fill:#71757f;fill:var(--devui-icon-fill, #71757f);transition:all cubic-bezier(.645,.045,.355,1) .3s;transition:all var(--devui-animation-ease-in-out-smooth, cubic-bezier(.645, .045, .355, 1)) var(--devui-animation-duration-slow, .3s)}.devui-category-search-icon.disabled{cursor:not-allowed}.devui-category-search-icon.disabled svg g path{fill:#cfd0d3;fill:var(--devui-disabled-text, #cfd0d3)}.devui-category-search-icon:not(.disabled):hover svg g path{fill:#252b3a;fill:var(--devui-icon-fill-hover, #252b3a)}input,input:focus{outline:none!important}a:focus,a:hover{color:#252b3a;color:var(--devui-list-item-hover-text, #252b3a)}d-tag{cursor:pointer}.devui-category-search-toggle{height:30px}.devui-date-picker-operation-area{border-top:1px solid #f2f2f3;border-top:1px solid var(--devui-dividing-line, #f2f2f3);margin:16px 0;padding:16px 16px 0;display:flex;justify-content:flex-end}.devui-date-picker-operation-area d-button:not(:first-child){margin-left:16px}.devui-dropdown-operation-area{border-top:1px solid #f2f2f3;border-top:1px solid var(--devui-dividing-line, #f2f2f3);padding-top:8px;margin:8px 0;display:flex;justify-content:center}.devui-dropdown-operation-area d-button:first-child{margin-right:8px}.devui-input-number-operation-area{padding:16px 16px 8px;display:flex;justify-content:space-evenly}.devui-save-panel{width:400px;height:auto;margin-top:4px}.devui-save-panel .devui-save-panel-title{display:flex;justify-content:space-between;height:48px;line-height:48px;border-bottom:1px solid #f2f2f3;border-bottom:1px solid var(--devui-dividing-line, #f2f2f3);padding:0 20px;font-size:14px;font-weight:700;color:16px;color:var(--devui-font-size-page-title, 16px)}.devui-save-panel .devui-save-filter-name{padding:16px 20px}.devui-save-panel .devui-save-filter-name>form{position:relative}.devui-save-panel .devui-save-filter-name>form svg{position:absolute;right:8px;top:50%;transform:translateY(-50%);cursor:pointer}.devui-save-panel .devui-save-filter-name>form svg path{fill:#71757f;fill:var(--devui-icon-fill, #71757f)}.devui-save-panel .devui-save-filter-name>form svg:hover svg g path{fill:#252b3a;fill:var(--devui-icon-fill-hover, #252b3a)}.devui-save-panel .devui-save-filter-name>span{padding-bottom:8px;display:block;line-height:1em}.devui-save-panel .devui-save-filter-name>input{width:100%;height:32px;margin:4px auto;line-height:20px;border:1px solid #d7d8da;border:1px solid var(--devui-form-control-line, #d7d8da)}.devui-save-panel .devui-save-panel-operation-area{padding-bottom:12px;display:flex;justify-content:center}.devui-save-panel .devui-save-panel-operation-area d-button:not(:first-child){margin-left:16px}.devui-dropdown-menu-template{max-width:300px;max-height:352px;overflow:auto}.devui-dropdown-menu-template .devui-category-search-group{font-size:12px;font-size:var(--devui-font-size, 12px)}.devui-dropdown-menu-template .devui-category-search-group.devui-dropdown-item:hover{background-color:transparent;color:#252b3a;color:var(--devui-text, #252b3a);cursor:default}.devui-selected-tags-list ul{display:flex;flex-flow:row wrap;align-items:center;justify-content:flex-start;padding:4px;max-height:390px;overflow:auto}.devui-selected-tags-list ul li{display:flex;flex-grow:0;flex-flow:row wrap}.devui-selected-tags-list ul li:first-child{margin-left:0}:host ::ng-deep .devui-tag-container{line-height:1}:host ::ng-deep .devui-tag-container d-tag>.devui-tag-item{display:block!important}:host ::ng-deep .devui-tag-container d-tag>.devui-tag-item>span{overflow:hidden;text-overflow:ellipsis;white-space:nowrap;display:inline-block;vertical-align:bottom;margin:0 4px}:host ::ng-deep .devui-checkbox-column-margin{height:32px!important;line-height:32px!important}::ng-deep .cdk-overlay-container d-datepicker[id=devui-category-search-date-picker] .devui-month-view{box-shadow:none!important}::ng-deep .cdk-overlay-container d-datepicker[id=devui-category-search-date-picker] .devui-month-view tfoot{display:none}::ng-deep .cdk-overlay-container .devui-selected-tags-list ul li .remove-button{right:8px}::ng-deep .cdk-overlay-container d-tag>.devui-tag-item{display:block!important}::ng-deep .cdk-overlay-container d-tag>.devui-tag-item>span{overflow:hidden;text-overflow:ellipsis;white-space:nowrap;display:inline-block;vertical-align:bottom;margin:0 4px}::ng-deep .devui-dropdown-top .devui-dropdown-menu-fix,::ng-deep .devui-dropdown-bottom .devui-dropdown-menu-fix,::ng-deep .devui-dropdown-open .devui-dropdown-menu-fix{margin-bottom:0}::ng-deep .devui-dropdown-menu-fix{min-width:200px;margin-left:0;overflow-y:auto;white-space:nowrap}::ng-deep .devui-dropdown-menu-fix.max-height{max-height:405px}::ng-deep .devui-dropdown-menu-fix .devui-checkbox-group{padding:8px 12px 0}::ng-deep .devui-dropdown-menu-fix .devui-checkbox-group .devui-color-block{width:12px;height:12px;margin-right:8px;border-radius:2px;border-radius:var(--devui-border-radius, 2px);top:-1px;position:relative;vertical-align:middle;display:inline-block}::ng-deep .devui-dropdown-menu-fix .devui-category-search-type-text-input{margin:16px 8px 8px;width:calc(100% - 16px)}::ng-deep .devui-dropdown-menu-fix .devui-select-list{display:flex;flex-wrap:wrap;max-width:300px;padding:8px}::ng-deep .devui-dropdown-menu-fix .devui-select-list span{margin-right:8px}::ng-deep .devui-dropdown-menu-fix .devui-search-container d-search{width:100%}::ng-deep .devui-dropdown-menu-fix .devui-search-container d-search .devui-search .devui-input.devui-clear-exit:not(.devui-icon-left){padding-right:28px}::ng-deep .devui-dropdown-menu-fix .devui-category-search-tree-container{overflow-y:auto;max-height:264px;padding:12px}::ng-deep .devui-dropdown-menu-fix .devui-no-data-tip{padding:12px}::ng-deep .devui-dropdown-menu-fix .devui-yearOption,::ng-deep .devui-dropdown-menu-fix .devui-monthOption{white-space:normal}::ng-deep .devui-dropdown-menu-fix d-datepicker-calendar{display:block}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox{margin:0 -8px;padding:0 8px}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox:hover{background-color:#f2f2f3;background-color:var(--devui-list-item-hover-bg, #f2f2f3)}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox:hover label{color:#252b3a;color:var(--devui-list-item-hover-text, #252b3a)}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox:active{background-color:#f2f5fc;background-color:var(--devui-list-item-active-bg, #f2f5fc)}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox:active label{color:#252b3a;color:var(--devui-list-item-active-text, #252b3a)}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox label{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;width:100%}::ng-deep .devui-dropdown-menu-fix d-input-number{width:70px}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group ul{max-height:310px}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox{transition:background-color .1s cubic-bezier(.645,.045,.355,1);transition:background-color var(--devui-animation-duration-fast, .1s) var(--devui-animation-ease-in-out-smooth, cubic-bezier(.645, .045, .355, 1))}::ng-deep .devui-dropdown-menu-template .devui-checkbox-group d-checkbox .devui-checkbox label{transition:color .1s cubic-bezier(.645,.045,.355,1);transition:color var(--devui-animation-duration-fast, .1s) var(--devui-animation-ease-in-out-smooth, cubic-bezier(.645, .045, .355, 1))}.devui-dropdown-menu-tip{cursor:text;padding:12px 12px 0;pointer-events:none;color:#71757f;color:var(--devui-aide-text, #71757f)}.devui-dividing-line{height:1px;width:100%;background-color:#f2f2f3;background-color:var(--devui-dividing-line, #f2f2f3);margin-top:4px}.devui-dropdown-menu{margin-top:4px;padding-bottom:0}.devui-dropdown-menu .devui-dropdown-item .icon-search{margin-right:4px}.devui-no-data-text{padding:8px 0;text-align:center}.devui-datepicker-footer{text-align:center}\n"] }]
        }], ctorParameters: function () {
        return [{ type: i1.DevConfigService }, { type: undefined, decorators: [{
                        type: Inject,
                        args: [DOCUMENT]
                    }] }, { type: i2.I18nService }];
    }, propDecorators: { category: [{
                type: Input
            }], defaultSearchField: [{
                type: Input
            }], selectedTags: [{
                type: Input
            }], allowClear: [{
                type: Input
            }], allowSave: [{
                type: Input
            }], allowShowMore: [{
                type: Input
            }], extendedConfig: [{
                type: Input
            }], toggleScrollToTail: [{
                type: Input
            }], searchKey: [{
                type: Input
            }], placeholderText: [{
                type: Input
            }], inputReadOnly: [{
                type: Input
            }], showSearchCategory: [{
                type: Input
            }], categoryInGroup: [{
                type: Input
            }], groupOrderConfig: [{
                type: Input
            }], customGroupNameTemplate: [{
                type: Input
            }], tagMaxWidth: [{
                type: Input
            }], textConfig: [{
                type: Input
            }], filterNameRules: [{
                type: Input
            }], beforeTagChange: [{
                type: Input
            }], toggleEvent: [{
                type: Input
            }], styleType: [{
                type: Input
            }], searchEvent: [{
                type: Output
            }], selectedTagsChange: [{
                type: Output
            }], createFilterEvent: [{
                type: Output
            }], clearAllEvent: [{
                type: Output
            }], searchKeyChange: [{
                type: Output
            }], inputEle: [{
                type: ViewChild,
                args: ['InputEle', { static: true }]
            }], scrollBarContainer: [{
                type: ViewChild,
                args: ['ScrollBarContainer', { static: true }]
            }], primeContainer: [{
                type: ViewChild,
                args: ['PrimeContainer', { static: true }]
            }], treeInstance: [{
                type: ViewChild,
                args: ['OperableTree']
            }], selectedDropdownList: [{
                type: ViewChildren,
                args: ['selectedDropdown']
            }], defaultTemplates: [{
                type: ViewChildren,
                args: [DefaultTemplateDirective]
            }], contentTemplates: [{
                type: ContentChildren,
                args: [ContentTemplateDirective]
            }] } });

class CategorySearchModule {
}
CategorySearchModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: CategorySearchModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
CategorySearchModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.1.5", ngImport: i0, type: CategorySearchModule, declarations: [CategorySearchComponent, ContentTemplateDirective, DefaultTemplateDirective], imports: [CommonModule,
        FormModule,
        FormsModule,
        DropDownModule,
        TextInputModule,
        SearchModule,
        TagsModule,
        ButtonModule,
        CheckBoxModule,
        InputNumberModule,
        LoadingModule,
        TreeModule,
        PopperModule,
        DatepickerProModule], exports: [CategorySearchComponent, ContentTemplateDirective, DefaultTemplateDirective] });
CategorySearchModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: CategorySearchModule, imports: [CommonModule,
        FormModule,
        FormsModule,
        DropDownModule,
        TextInputModule,
        SearchModule,
        TagsModule,
        ButtonModule,
        CheckBoxModule,
        InputNumberModule,
        LoadingModule,
        TreeModule,
        PopperModule,
        DatepickerProModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.5", ngImport: i0, type: CategorySearchModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        FormModule,
                        FormsModule,
                        DropDownModule,
                        TextInputModule,
                        SearchModule,
                        TagsModule,
                        ButtonModule,
                        CheckBoxModule,
                        InputNumberModule,
                        LoadingModule,
                        TreeModule,
                        PopperModule,
                        DatepickerProModule,
                    ],
                    declarations: [CategorySearchComponent, ContentTemplateDirective, DefaultTemplateDirective],
                    exports: [CategorySearchComponent, ContentTemplateDirective, DefaultTemplateDirective],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { ALLOWED_SEARCH_FIELD_TYPES, COLORS, CategorySearchComponent, CategorySearchModule, ContentTemplateDirective, DefaultTemplateDirective };
//# sourceMappingURL=ng-devui-category-search.mjs.map
