import { Theme, devuiDarkTheme } from 'ng-devui/theme';

const devuiCustomComponentsThemeData = {
    'devui-btn-sm-padding': '0 12px',
    'devui-btn-padding': '0 16px',
    'devui-btn-lg-padding': '0 20px',
    'devui-btn-common-bg': '#EBEBEB',
    'devui-btn-common-border-color': 'transparent',
    'devui-btn-common-bg-hover': '#D1D1D1',
    'devui-btn-common-color-hover': '#252B3A',
    'devui-btn-common-border-color-hover': 'transparent',
    'devui-btn-common-bg-active': '#BDBDBD',
    'devui-btn-common-color-active': '#252B3A',
    'devui-btn-common-border-color-active': 'transparent',
    'devui-btn-common-border-disabled': 'transparent',
    'devui-icon-hover-bg': '#EBEBEB',
    'devui-icon-active-bg': '#D1D1D1'
};
const devuiCustomComponentsDarkThemeData = {
    'devui-btn-sm-padding': '0 12px',
    'devui-btn-padding': '0 16px',
    'devui-btn-lg-padding': '0 20px',
    'devui-btn-common-bg': '#393a3e',
    'devui-btn-common-border-color': 'transparent',
    'devui-btn-common-bg-hover': '#4e5057',
    'devui-btn-common-color-hover': '#CED1DB',
    'devui-btn-common-border-color-hover': 'transparent',
    'devui-btn-common-bg-active': '#4e5057',
    'devui-btn-common-color-active': '#CED1DB',
    'devui-btn-common-border-color-active': 'transparent',
    'devui-btn-common-border-disabled': 'transparent',
    'devui-icon-hover-bg': '#393a3e',
    'devui-icon-active-bg': '#4e5057'
};
const devuiCustomComponentsDeepThemeData = {
    'devui-btn-common-bg': '#E0E0E0',
    'devui-btn-common-bg-hover': '#BDBDBD',
    'devui-btn-common-bg-active': '#A1A1A1'
};

const devuiInitialThemeData = {
    'devui-global-bg': '#f7f7f9',
    'devui-glass-morphism-bg': 'rgba(247, 247, 249, 0.9)',
    'devui-global-bg-normal': '#ffffff',
    'devui-base-bg': '#ffffff',
    'devui-base-bg-dark': '#252b3a',
    'devui-brand': '#5e7ce0',
    'devui-brand-foil': '#f2f2f3',
    'devui-brand-hover': '#7693f5',
    'devui-brand-active': '#526ecc',
    'devui-brand-active-focus': '#344899',
    'devui-contrast': '#c7000b',
    'devui-text': '#252b3a',
    'devui-text-weak': '#575d6c',
    'devui-aide-text': '#71757f',
    'devui-aide-text-hover': '#252b3a',
    'devui-aide-text-stress': '#575d6c',
    'devui-placeholder': '#babbc0',
    'devui-light-text': '#ffffff',
    'devui-dark-text': '#252b3a',
    'devui-link': '#526ecc',
    'devui-link-active': '#526ecc',
    'devui-link-light': '#96adfa',
    'devui-link-light-active': '#beccfa',
    'devui-line': '#d7d8da',
    'devui-dividing-line': '#f2f2f3',
    'devui-block': '#ffffff',
    'devui-area': '#f5f5f5',
    'devui-danger': '#f66f6a',
    'devui-warning': '#fac20a',
    'devui-waiting': '#beccfa',
    'devui-success': '#50d4ab',
    'devui-info': '#5e7ce0',
    'devui-initial': '#e9edfa',
    'devui-unavailable': '#f5f5f5',
    'devui-shadow': 'rgba(37, 43, 58, 0.2)',
    'devui-light-shadow': 'rgba(37, 43, 58, 0.1)',
    'devui-connected-overlay-shadow': 'rgba(37, 43, 58, 0.12)',
    'devui-feedback-overlay-shadow': 'rgba(37, 43, 58, 0.16)',
    'devui-icon-text': '#71757f',
    'devui-icon-bg': '#ffffff',
    'devui-icon-fill': '#71757f',
    'devui-icon-fill-weak': '#babbc0',
    'devui-icon-fill-hover': '#252b3a',
    'devui-icon-fill-active': '#252b3a',
    'devui-icon-fill-active-hover': '#252b3a',
    'devui-shape-icon-fill': '#d7d8da',
    'devui-shape-icon-fill-hover': '#babbc0',
    'devui-shape-icon-fill-active': '#babbc0',
    'devui-shape-icon-fill-disabled': '#f5f5f5',
    'devui-form-control-line': '#d7d8da',
    'devui-form-control-bg': '#ffffff',
    'devui-form-control-line-hover': '#9b9fa8',
    'devui-form-control-line-active': '#5e7ce0',
    'devui-form-control-line-active-hover': '#344899',
    'devui-list-item-active-bg': '#f2f5fc',
    'devui-list-item-active-text': '#252b3a',
    'devui-list-item-active-hover-bg': '#f2f5fc',
    'devui-list-item-hover-bg': '#f2f2f3',
    'devui-list-item-hover-text': '#252b3a',
    'devui-list-item-selected-bg': '#f2f5fc',
    'devui-list-item-strip-bg': '#f2f5fc',
    'devui-disabled-bg': '#f5f5f5',
    'devui-disabled-line': '#dfe1e6',
    'devui-disabled-text': '#cfd0d3',
    'devui-primary-disabled': '#beccfa',
    'devui-icon-fill-active-disabled': '#beccfa',
    'devui-label-bg': '#e9edfa',
    'devui-connected-overlay-bg': '#ffffff',
    'devui-connected-overlay-line': '#526ecc',
    'devui-fullscreen-overlay-bg': '#ffffff',
    'devui-feedback-overlay-bg': '#464d6e',
    'devui-feedback-overlay-text': '#dfe1e6',
    'devui-embed-search-bg': '#f2f2f3',
    'devui-embed-search-bg-hover': '#eef0f5',
    'devui-float-block-shadow': 'rgba(94, 124, 224, 0.3)',
    'devui-highlight-overlay': 'rgba(255, 255, 255, 0.8)',
    'devui-range-item-hover-bg': '#e9edfa',
    'devui-gray-form-control-bg': '#f5f5f5',
    'devui-gray-form-control-hover-bg': '#ebebeb',
    'devui-nav-expand-bg': '#fbfbfc',
    'devui-primary': '#5e7ce0',
    'devui-primary-hover': '#7693f5',
    'devui-primary-active': '#344899',
    'devui-contrast-hover': '#d64a52',
    'devui-contrast-active': '#b12220',
    'devui-danger-line': '#f66f6a',
    'devui-danger-bg': '#ffd5d4',
    'devui-warning-line': '#fa9841',
    'devui-warning-bg': '#ffe1c7',
    'devui-info-line': '#5e7ce0',
    'devui-info-bg': '#e9edfa',
    'devui-success-line': '#50d4ab',
    'devui-success-bg': '#cffcee',
    'devui-primary-line': '#5e7ce0',
    'devui-primary-bg': '#f2f5fc',
    'devui-default-line': '#5e7ce0',
    'devui-default-bg': '#f7f8fa',
    'devui-shadow-length-base': '0 1px 4px 0',
    'devui-shadow-length-slide-left': '-2px 0 8px 0',
    'devui-shadow-length-slide-right': '2px 0 8px 0',
    'devui-shadow-length-connected-overlay': '0 2px 8px 0',
    'devui-shadow-length-hover': '0 6px 16px 0',
    'devui-shadow-length-feedback-overlay': '0 8px 16px 0',
    'devui-shadow-length-fullscreen-overlay': '0 12px 24px 0',
    'devui-border-radius': '4px',
    'devui-border-radius-feedback': '4px',
    'devui-border-radius-card': '8px',
    'devui-border-radius-full': '100px',
    'devui-font-size': '14px',
    'devui-font-size-card-title': '16px',
    'devui-font-size-page-title': '16px',
    'devui-font-size-modal-title': '18px',
    'devui-font-size-price': '20px',
    'devui-font-size-data-overview': '24px',
    'devui-font-size-icon': '16px',
    'devui-font-size-sm': '12px',
    'devui-font-size-md': '14px',
    'devui-font-size-lg': '14px',
    'devui-font-title-weight': 'bold',
    'devui-font-content-weight': 'normal',
    'devui-line-height-base': '1.5',
    'devui-animation-ease-in-smooth': 'cubic-bezier(0.645, 0.045, 0.355, 1)',
    'devui-animation-duration-slow': '300ms',
    'devui-animation-duration-base': '200ms',
    'devui-animation-duration-fast': '100ms',
    'devui-animation-ease-in': 'cubic-bezier(0.5, 0, 0.84, 0.25)',
    'devui-animation-ease-out': 'cubic-bezier(0.16, 0.75, 0.5, 1)',
    'devui-animation-ease-in-out': 'cubic-bezier(0.5, 0.05, 0.5, 0.95)',
    'devui-animation-ease-in-out-smooth': 'cubic-bezier(0.645, 0.045, 0.355, 1)',
    'devui-animation-linear': 'cubic-bezier(0, 0, 1, 1)',
    'devui-z-index-full-page-overlay': '1080',
    'devui-z-index-pop-up': '1060',
    'devui-z-index-dropdown': '1052',
    'devui-z-index-modal': '1050',
    'devui-z-index-drawer': '1040',
    'devui-z-index-framework': '1000',
};

const infinityTheme = new Theme({
    id: 'infinity-theme',
    name: '无限主题',
    data: { ...devuiInitialThemeData, ...devuiCustomComponentsThemeData },
    extends: 'devui-light-theme',
    isDark: false,
});
const provenceTheme = new Theme({
    id: 'provence-theme',
    name: '紫罗兰主题',
    data: {
        ...infinityTheme.data,
        'devui-brand': '#7B69EE',
        'devui-brand-foil': '#F5F5F9',
        'devui-brand-active-focus': '#7B69EE',
        'devui-primary-active': '#7B69EE',
        'devui-brand-hover': '#7B69EE',
        'devui-global-bg': '#f9fafb',
        'devui-glass-morphism-bg': 'rgba(249,250,251,0.9)',
        'devui-base-bg': '#ffffff',
        'devui-text': '#070036',
        'devui-aide-text': '#717087',
        'devui-placeholder': '#babbc0',
        'devui-disabled-text': '#cfd0d3',
        'devui-disabled-bg': '#f5f5f6',
        'devui-line': '#E2E2E5',
        'devui-dividing-line': '#F2F2F3',
        'devui-list-item-hover-bg': '#F5F5F9',
        'devui-list-item-active-bg': '#7B69EE',
        'devui-list-item-active-hover-bg': '#7B69EE',
        'devui-list-item-selected-bg': '#F4F2FF',
        'devui-list-item-hover-text': '#252b3a',
        'devui-list-item-active-text': '#ffffff',
        'devui-form-control-line': '#D7D8DA',
        'devui-icon-text': '#babbc0',
        'devui-brand-active': '#7B69EE',
        'devui-primary': '#7B69EE',
        'devui-primary-hover': '#7B69EE',
        'devui-form-control-line-active': '#7B69EE',
        'devui-form-control-line-active-hover': '#7B69EE',
        'devui-icon-fill-active': '#7B69EE',
        'devui-icon-fill-active-hover': '#7B69EE',
        'devui-label-bg': '#F4F2FF',
        'devui-embed-search-bg': '#F4F2FF',
        'devui-connected-overlay-line': '#7B69EE',
        'devui-primary-disabled': '#d8d2fa',
        'devui-icon-fill-active-disabled': '#d8d2fa',
        'devui-link-active': '#3f1a9c',
        'devui-gray-form-control-bg': '#f5f5f5',
        'devui-gray-form-control-hover-bg': '#ebebeb',
    },
    extends: 'infinity-theme',
    isDark: false,
});
const sweetTheme = new Theme({
    id: 'sweet-theme',
    name: '蜜糖主题',
    data: {
        ...infinityTheme.data,
        'devui-brand': '#ec66ab',
        'devui-brand-foil': '#f8f1f5',
        'devui-brand-active-focus': '#ec66ab',
        'devui-primary-active': '#ec66ab',
        'devui-brand-hover': '#ec66ab',
        'devui-global-bg': '#f9fafb',
        'devui-glass-morphism-bg': 'rgba(249,250,251,0.9)',
        'devui-base-bg': '#ffffff',
        'devui-text': '#2f272f',
        'devui-aide-text': '#827d82',
        'devui-placeholder': '#bdb8bd',
        'devui-disabled-text': '#cbcacb',
        'devui-disabled-bg': '#f6f6f6',
        'devui-line': '#aea6ad',
        'devui-dividing-line': '#eae7e9',
        'devui-list-item-hover-bg': '#f8f1f5',
        'devui-list-item-active-bg': '#ffdcee',
        'devui-list-item-active-hover-bg': '#ffdcee',
        'devui-list-item-selected-bg': '#ffdcee',
        'devui-list-item-hover-text': '#252b3a',
        'devui-list-item-active-text': '#252b3a',
        'devui-form-control-line': '#D7D8DA',
        'devui-icon-text': '#babbc0',
        'devui-brand-active': '#ec66ab',
        'devui-primary': '#ec66ab',
        'devui-primary-hover': '#ec66ab',
        'devui-form-control-line-active': '#ec66ab',
        'devui-form-control-line-active-hover': '#ec66ab',
        'devui-icon-fill-active': '#ec66ab',
        'devui-icon-fill-active-hover': '#ec66ab',
        'devui-label-bg': '#ffdcee',
        'devui-embed-search-bg': '#ffdcee',
        'devui-connected-overlay-line': '#ec66ab',
        'devui-primary-disabled': '#fad1e6',
        'devui-icon-fill-active-disabled': '#fad1e6',
        'devui-link-active': '#96114d',
        'devui-gray-form-control-bg': '#f5f5f5',
        'devui-gray-form-control-hover-bg': '#ebebeb',
    },
    extends: 'infinity-theme',
    isDark: false,
});
const deepTheme = new Theme({
    id: 'deep-theme',
    name: '深邃夜空主题',
    data: {
        ...infinityTheme.data,
        ...devuiCustomComponentsDeepThemeData,
        'devui-global-bg': '#F2F2F3',
        'devui-glass-morphism-bg': 'rgba(242,242,243,0.9)',
        'devui-base-bg': '#ffffff',
        'devui-brand': '#252b3a',
        'devui-brand-foil': '#f3f4f7',
        'devui-brand-active-focus': '#252b3a',
        'devui-primary-active': '#383e4d',
        'devui-brand-active': '#252b3a',
        'devui-brand-hover': '#252b3a',
        'devui-text': '#252b3a',
        'devui-aide-text': '#575d6c',
        'devui-placeholder': '#9B9FA8',
        'devui-disabled-text': '#9B9FA8',
        'devui-disabled-bg': '#EBEBEB',
        'devui-line': '#CFD0D3',
        'devui-dividing-line': '#E2E2E6',
        'devui-list-item-hover-bg': '#E2E2E6',
        'devui-list-item-active-bg': '#d5d5db',
        'devui-list-item-active-hover-bg': '#d5d5db',
        'devui-list-item-selected-bg': '#d5d5db',
        'devui-list-item-hover-text': '#252b3a',
        'devui-list-item-active-text': '#252b3a',
        'devui-icon-text': '#babbc0',
        'devui-primary': '#252b3a',
        'devui-primary-hover': '#575d6c',
        'devui-form-control-line': '#CFD0D3',
        'devui-form-control-line-hover': '#71757F',
        'devui-icon-fill': '#575d6c',
        'devui-icon-fill-weak': '#9B9FA8',
        'devui-icon-fill-active': '#252B3A',
        'devui-icon-fill-active-hover': '#252B3A',
        'devui-shape-icon-fill': '#C7C7D1',
        'devui-shape-icon-fill-hover': '#AEAEBD',
        'devui-shape-icon-fill-active': '#AEAEBD',
        'devui-shape-icon-fill-disabled': '#E0E0E0',
        'devui-form-control-line-active': '#252b3a',
        'devui-form-control-line-active-hover': '#252b3a',
        'devui-connected-overlay-line': '#252b3a',
        'devui-primary-disabled': '#babbc0',
        'devui-icon-fill-active-disabled': '#bebfc4',
        'devui-gray-form-control-bg': '#f5f5f5',
        'devui-gray-form-control-hover-bg': '#ebebeb',
        'devui-nav-expand-bg': '#f7f7f8'
    },
    extends: 'infinity-theme',
    isDark: false,
});
const galaxyTheme = new Theme({
    id: 'galaxy-theme',
    name: '追光主题',
    data: {
        ...devuiDarkTheme.data,
        ...devuiCustomComponentsDarkThemeData,
        // use '526ECC' for active status except 'devui-list-item-active-bg'
        'devui-brand': '#526ECC',
        'devui-info': '#526ECC',
        'devui-primary': '#526ECC',
        'devui-default-line': '#526ECC',
        'devui-brand-hover': '#5E7CE0',
        'devui-primary-hover': '#5E7CE0',
        'devui-brand-foil': '#F2F2F3',
        'devui-global-bg': '#1A1A1C',
        'devui-glass-morphism-bg': 'rgba(26,26,28,0.9)',
        'devui-base-bg': '#292A2E',
        'devui-text': '#CED1DB',
        'devui-aide-text': '#868A99',
        'devui-placeholder': '#5B5D66',
        'devui-disabled-text': '#5b5d66',
        'devui-disabled-bg': '#2D2E32',
        'devui-line': '#4e5057',
        'devui-dividing-line': '#323438',
        'devui-list-item-hover-bg': '#3d3d42',
        'devui-list-item-active-bg': '#303548',
        'devui-list-item-active-hover-bg': '#303548',
        'devui-list-item-selected-bg': '#303548',
        'devui-list-item-hover-text': '#F5F5F5',
        'devui-list-item-active-text': '#4660B8',
        'devui-primary-disabled': '#3f3f3f',
        'devui-form-control-line': '#4e5057',
        'devui-form-control-bg': '#292A2E',
        'devui-form-control-line-hover': '#696c75',
        'devui-form-control-line-active': '#526ECC',
        'devui-icon-text': '#868A99',
        'devui-connected-overlay-bg': '#2E2F33',
        'devui-fullscreen-overlay-bg': '#2E2F33',
        'devui-warning-line': '#EB8F3D',
        'devui-warning-bg': '#4b2e14',
        'devui-success-line': '#2AA37E ',
        'devui-success-bg': '#123d32',
        'devui-danger-line': '#D15854',
        'devui-danger-bg': '#4a2120',
        'devui-info-line': '#4482BD',
        'devui-info-bg': '#1c2543',
        'devui-default-bg': '#313131',
        'devui-label-bg': '#353537',
        'devui-icon-fill': '#868A99',
        'devui-icon-fill-hover': '#ced1db',
        'devui-icon-fill-active': '#ced1db',
        'devui-icon-fill-active-hover': '#ced1db',
        'devui-border-radius': '4px',
        'devui-border-radius-feedback': '4px',
        'devui-border-radius-card': '8px',
        'devui-font-size': '14px',
        'devui-font-size-md': '14px',
        'devui-font-size-card-title': '16px',
        'devui-shadow-length-fullscreen-overlay': '0 0 6px 0',
        'devui-gray-form-control-bg': '#323338',
        'devui-gray-form-control-hover-bg': '#393A3E',
        'devui-nav-expand-bg': '#1d1d21'
    },
    extends: 'devui-dark-theme',
    isDark: true,
});

const devuiSwatches = {
    'devui-blue-5': '#f2f5fc',
    'devui-blue-10': '#e9edfa',
    'devui-blue-20': '#beccfa',
    'devui-blue-30': '#96adfa',
    'devui-blue-40': '#7693f5',
    'devui-blue-50': '#5e7ce0',
    'devui-blue-60': '#526ecc',
    'devui-blue-70': '#465eb8',
    'devui-blue-80': '#3c51a6',
    'devui-blue-90': '#344899',
    'devui-blue-100': '#2a3c85',
    'devui-sky-5': '#ebf6ff',
    'devui-sky-10': '#d1ebff',
    'devui-sky-20': '#b8e0ff',
    'devui-sky-30': '#9ed5ff',
    'devui-sky-40': '#85caff',
    'devui-sky-50': '#6cbfff',
    'devui-sky-60': '#4ea6e6',
    'devui-sky-70': '#3590cc',
    'devui-sky-80': '#207ab3',
    'devui-sky-90': '#0f6999',
    'devui-sky-100': '#035880',
    'devui-green-5': '#edfff9',
    'devui-green-10': '#cffcee',
    'devui-green-20': '#acf2dc',
    'devui-green-30': '#8be8cb',
    'devui-green-40': '#6ddebb',
    'devui-green-50': '#50d4ab',
    'devui-green-60': '#3ac295',
    'devui-green-70': '#27b080',
    'devui-green-80': '#169e6c',
    'devui-green-90': '#088c58',
    'devui-green-100': '#007a45',
    'devui-lime-5': '#f0ffe6',
    'devui-lime-10': '#e5ffd4',
    'devui-lime-20': '#d8fcc0',
    'devui-lime-30': '#c5f2a7',
    'devui-lime-40': '#b3e890',
    'devui-lime-50': '#a6dd82',
    'devui-lime-60': '#92cc68',
    'devui-lime-70': '#7eba50',
    'devui-lime-80': '#6ca83b',
    'devui-lime-90': '#5e9629',
    'devui-lime-100': '#518519',
    'devui-yellow-5': '#fffbf0',
    'devui-yellow-10': '#fff1c2',
    'devui-yellow-20': '#ffe794',
    'devui-yellow-30': '#ffdc66',
    'devui-yellow-40': '#ffd138',
    'devui-yellow-50': '#fac20a',
    'devui-yellow-60': '#e3aa00',
    'devui-yellow-70': '#cc9600',
    'devui-yellow-80': '#b58200',
    'devui-yellow-90': '#9e6f00',
    'devui-yellow-100': '#875c00',
    'devui-orange-5': '#fff3e8',
    'devui-orange-10': '#ffe1c7',
    'devui-orange-20': '#ffd0a6',
    'devui-orange-30': '#ffbf85',
    'devui-orange-40': '#ffad63',
    'devui-orange-50': '#fa9841',
    'devui-orange-60': '#e37d29',
    'devui-orange-70': '#cc6414',
    'devui-orange-80': '#b54e04',
    'devui-orange-90': '#9e3f00',
    'devui-orange-100': '#873400',
    'devui-red-5': '#ffeeed',
    'devui-red-10': '#ffd5d4',
    'devui-red-20': '#ffbcba',
    'devui-red-30': '#ffa4a1',
    'devui-red-40': '#ff8b87',
    'devui-red-50': '#f66f6a',
    'devui-red-60': '#de504e',
    'devui-red-70': '#c73636',
    'devui-red-80': '#b02121',
    'devui-red-90': '#991111',
    'devui-red-100': '#820404',
    'devui-magenta-5': '#ffedf3',
    'devui-magenta-10': '#ffd4e3',
    'devui-magenta-20': '#ffbad2',
    'devui-magenta-30': '#ffa1c2',
    'devui-magenta-40': '#fc86b0',
    'devui-magenta-50': '#f3689a',
    'devui-magenta-60': '#db4d83',
    'devui-magenta-70': '#c4356e',
    'devui-magenta-80': '#ad215b',
    'devui-magenta-90': '#96114d',
    'devui-magenta-100': '#800440',
    'devui-purple-5': '#f5f0ff',
    'devui-purple-10': '#e7d9ff',
    'devui-purple-20': '#d8c2ff',
    'devui-purple-30': '#caabff',
    'devui-purple-40': '#bc94ff',
    'devui-purple-50': '#a97af8',
    'devui-purple-60': '#8a5ce0',
    'devui-purple-70': '#6f42c9',
    'devui-purple-80': '#572db3',
    'devui-purple-90': '#3f1a9c',
    'devui-purple-100': '#2a0c85',
    'devui-gray-5': '#f5f5f5',
    'devui-gray-10': '#ebebeb',
    'devui-gray-20': '#e0e0e0',
    'devui-gray-30': ' #d1d1d1',
    'devui-gray-40': '#bdbdbd',
    'devui-gray-50': '#a1a1a1',
    'devui-gray-60': '#878787',
    'devui-gray-70': '#707070',
    'devui-gray-80': '#5c5c5c',
    'devui-gray-90': '#474747',
    'devui-gray-100': '#383838',
    'devui-slate-5': '#f7f8fa',
    'devui-slate-10': '#eef0f5',
    'devui-slate-20': '#dfe1e6',
    'devui-slate-30': '#d7d8da',
    'devui-slate-40': '#cfd0d3',
    'devui-slate-50': '#babbc0',
    'devui-slate-60': '#9b9fa8',
    'devui-slate-70': '#71757f',
    'devui-slate-80': '#575d6c',
    'devui-slate-90': '#383e4d',
    'devui-slate-100': '#252b3a',
    'devui-zinc-5': '#f7f7f9',
    'devui-zinc-10': '#f2f2f3',
    'devui-zinc-20': '#e2e2e6',
    'devui-zinc-30': '#d5d5db',
    'devui-zinc-40': '#c7c7d1',
    'devui-zinc-50': '#aeaebd',
    'devui-zinc-60': '#9696a3',
    'devui-zinc-70': '#7a7a85',
    'devui-zinc-80': '#63636b',
    'devui-zinc-90': '#494952',
    'devui-zinc-100': '#37373d',
    'devui-dark-gray-5': '#16181a',
    'devui-dark-gray-10': '#202124',
    'devui-dark-gray-20': '#292a2e',
    'devui-dark-gray-30': '#2e2f33',
    'devui-dark-gray-40': '#323338',
    'devui-dark-gray-50': '#393a3e',
    'devui-dark-gray-60': '#4e5057',
    'devui-dark-gray-70': '#696c75',
    'devui-dark-gray-80': '#868a99',
    'devui-dark-gray-90': '#acb0bd',
    'devui-dark-gray-100': '#ced1db',
    'devui-dark-slate-5': '#0e111a',
    'devui-dark-slate-10': '#141721',
    'devui-dark-slate-20': '#1a1e29',
    'devui-dark-slate-30': '#232633',
    'devui-dark-slate-40': '#2c303e',
    'devui-dark-slate-50': '#33384b',
    'devui-dark-slate-60': '#444b61',
    'devui-dark-slate-70': '#626a85',
    'devui-dark-slate-80': '#878ea8',
    'devui-dark-slate-90': '#a3aac2',
    'devui-dark-slate-100': '#c1c7db',
    'devui-dark-zinc-5': '#1a1a1c',
    'devui-dark-zinc-10': '#212124',
    'devui-dark-zinc-20': '#28282b',
    'devui-dark-zinc-30': '#2f2f33',
    'devui-dark-zinc-40': '#353537',
    'devui-dark-zinc-50': '#3d3d42',
    'devui-dark-zinc-60': '#4b4b52',
    'devui-dark-zinc-70': '#575861',
    'devui-dark-zinc-80': '#767680',
    'devui-dark-zinc-90': '#9898a3',
    'devui-dark-zinc-100': '#b7b7c7',
    'devui-white-5': '#ffffff',
    'devui-black-5': '#000000'
};

/**
 * Generated bundle index. Do not edit.
 */

export { deepTheme, devuiCustomComponentsDarkThemeData, devuiCustomComponentsDeepThemeData, devuiCustomComponentsThemeData, devuiInitialThemeData, devuiSwatches, galaxyTheme, infinityTheme, provenceTheme, sweetTheme };
//# sourceMappingURL=ng-devui-theme-collection.mjs.map
