export type DJustify = 'start' | 'end' | 'center' | 'around' | 'between';
export type DAlign = 'start' | 'center' | 'end' | 'baseline' | 'stretch';
export type DAlignSelf = 'start' | 'center' | 'end' | 'baseline' | 'stretch';
export type DBreakpoint = 'ss' | 'ms' | 'mm' | 'ml' | 'xs' | 'sm' | 'md' | 'lg' | 'xl';
export declare const DBreakpoints: DBreakpoint[];
export declare const DBreakpointsMap: {
    ss: number;
    ms: number;
    mm: number;
    ml: number;
    xs: number;
    sm: number;
    md: number;
    lg: number;
    xl: number;
};
export interface DMergedProperty {
    daSpan?: number;
    daOffset?: number;
    daAlign?: DAlign;
    daJustify?: DJustify;
    daAlignSelf?: DAlignSelf;
    daOrder?: number;
}
export type DResponseParameter<T> = T | {
    ss?: T;
    ms?: T;
    mm?: T;
    ml?: T;
    xs?: T;
    sm?: T;
    md?: T;
    lg?: T;
    xl?: T;
};
