import { OnInit, TemplateRef } from '@angular/core';
import { DomSanitizer } from '@angular/platform-browser';
import { IButtonStyle } from 'ng-devui/button';
import { ModalComponent } from './modal.component';
import { ModalContentDirective } from './modal.directive';
import * as i0 from "@angular/core";
export declare class ModalContainerComponent implements OnInit {
    private sanitizer;
    modalInstance: ModalComponent;
    maxHeight: string;
    data: any;
    title: string;
    content: string | HTMLElement;
    buttons: Array<{
        id?: string;
        cssClass?: IButtonStyle;
        text: string;
        handler: ($event: Event) => void;
        btnwidth?: string;
        autofocus?: boolean;
        disabled: boolean;
    }>;
    html: boolean;
    onClose: ($event?: Event) => void;
    modalContentHost: ModalContentDirective;
    dialogtype: string;
    showCloseBtn: boolean;
    contentTemplate: TemplateRef<any>;
    constructor(sanitizer: DomSanitizer, modalInstance: ModalComponent);
    ngOnInit(): void;
    close(event: any): void;
    updateButtonOptions(buttonOptions?: any[]): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ModalContainerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ModalContainerComponent, "d-modal-container", never, { "maxHeight": "maxHeight"; "data": "data"; "title": "title"; "content": "content"; "buttons": "buttons"; "html": "html"; "onClose": "onClose"; "dialogtype": "dialogtype"; "showCloseBtn": "showCloseBtn"; }, {}, never, never, false, never>;
}
