import { ElementRef, OnChanges, OnInit, SimpleChanges } from '@angular/core';
import { ThemeService } from 'ng-devui/theme';
import { IAxisConfigs, IViewConfigs } from '../quadrant-diagram.type';
import * as i0 from "@angular/core";
export declare class QuadrantDiagramAxisComponent implements OnInit, OnChanges {
    private elementRef;
    axisConfigs: IAxisConfigs;
    view: IViewConfigs;
    diagramId: any;
    quadrantAxis: any;
    context: any;
    axisOrigin: any;
    axisTop: number;
    axisRight: number;
    axisWidth: number;
    axisHeight: number;
    yAxisTicksNum: number;
    xAxisTicksNum: number;
    xTickSpacing: number;
    yTickSpacing: number;
    private AXIS_COLOR;
    private AXIS_LABEL_COLOR;
    themeService: ThemeService;
    constructor(elementRef: ElementRef);
    ngOnChanges(changes: SimpleChanges): void;
    ngOnInit(): void;
    refreshColor: () => void;
    resetAxis(): void;
    initAxisData(): void;
    setAxisData(): void;
    drawAxis(): void;
    drawXAxisTicks(): void;
    drawYAxisTicks(): void;
    drawYAxis(): void;
    drawXAxis(): void;
    drawAxisLabels(): void;
    drawAxisTitle(): void;
    drawXTicksLabels(): void;
    drawYTicksLabels(): void;
    rotateLabel(name: any, x: any, y: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<QuadrantDiagramAxisComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<QuadrantDiagramAxisComponent, "d-quadrant-axis", never, { "axisConfigs": "axisConfigs"; "view": "view"; "diagramId": "diagramId"; }, {}, never, never, false, never>;
}
