import { AfterViewInit, ChangeDetectorRef, ElementRef, OnDestroy, OnInit, Renderer2 } from '@angular/core';
import { I18nService } from 'ng-devui/i18n';
import { Subscription } from 'rxjs';
import { ResizeDirective } from './resize.directive';
import { SplitterService } from './splitter.service';
import { SplitterOrientation } from './splitter.types';
import * as i0 from "@angular/core";
export declare class SplitterBarComponent implements OnInit, AfterViewInit, OnDestroy {
    private el;
    private splitter;
    private renderer;
    private resize;
    private cdr;
    private cdrSelf;
    private i18n;
    index: number;
    orientation: SplitterOrientation;
    showCollapseButton: any;
    collapsePosLeft: string;
    collapsePosTop: string;
    _splitBarSize: any;
    set splitBarSize(size: any);
    get splitBarSize(): any;
    disabledBarSize: any;
    get class(): string;
    splitterText: any;
    preTip: any;
    nextTip: any;
    subscriptions: Subscription;
    private stopPropagation;
    private moveStream;
    constructor(el: ElementRef, splitter: SplitterService, renderer: Renderer2, resize: ResizeDirective, cdr: ChangeDetectorRef, cdrSelf: ChangeDetectorRef, i18n: I18nService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    initialCollapseStatus(): void;
    collapsePrePane(lockStatus?: any): void;
    collapseNextPane(lockStatus?: any): void;
    queryPanes(index: any, nearIndex: any): {
        pane: import("ng-devui/splitter").SplitterPaneComponent;
        nearPane: import("ng-devui/splitter").SplitterPaneComponent;
    };
    toggleResize(): void;
    get prevClass(): string;
    get nextClass(): string;
    generateClass(classes: any): string;
    generateCollapseClass(pane: any, nearPane: any, showIcon: any): string;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SplitterBarComponent, [null, null, null, { host: true; }, { skipSelf: true; }, null, null]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SplitterBarComponent, "d-splitter-bar", never, { "index": "index"; "orientation": "orientation"; "showCollapseButton": "showCollapseButton"; "collapsePosLeft": "collapsePosLeft"; "collapsePosTop": "collapsePosTop"; "splitBarSize": "splitBarSize"; "disabledBarSize": "disabledBarSize"; }, {}, never, never, false, never>;
}
