import { AfterContentInit, ChangeDetectorRef, ElementRef, OnChanges, OnDestroy, QueryList, SimpleChanges } from '@angular/core';
import { Subscription } from 'rxjs';
import { SplitterPaneComponent } from './splitter-pane.component';
import { SplitterService } from './splitter.service';
import { SplitterOrientation } from './splitter.types';
import * as i0 from "@angular/core";
export declare class SplitterComponent implements OnChanges, AfterContentInit, OnDestroy {
    private el;
    private splitter;
    private cdr;
    orientation: SplitterOrientation;
    splitBarSize: string;
    disabledBarSize: string;
    showCollapseButton: boolean;
    collapsePosLeft: string;
    collapsePosTop: string;
    get class(): string;
    panes: QueryList<SplitterPaneComponent>;
    paneChangesSubscription: Subscription;
    constructor(el: ElementRef, splitter: SplitterService, cdr: ChangeDetectorRef);
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterContentInit(): void;
    ngOnDestroy(): void;
    reconfigure(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SplitterComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SplitterComponent, "d-splitter", ["dSplitter"], { "orientation": "orientation"; "splitBarSize": "splitBarSize"; "disabledBarSize": "disabledBarSize"; "showCollapseButton": "showCollapseButton"; "collapsePosLeft": "collapsePosLeft"; "collapsePosTop": "collapsePosTop"; }, {}, ["panes"], ["d-splitter-pane"], false, never>;
}
