import { AfterViewInit, ElementRef, OnDestroy, OnInit, Renderer2 } from '@angular/core';
import { I18nInterface, I18nService } from 'ng-devui/i18n';
import { PositionService } from 'ng-devui/position';
import { Subscription } from 'rxjs';
import { StepsGuideService } from './steps-guide.service';
import { ExtraConfig } from './steps-guide.types';
import * as i0 from "@angular/core";
export declare class StepsGuideComponent implements OnInit, AfterViewInit, OnDestroy {
    private stepService;
    private renderer;
    private positionService;
    private elm;
    private i18n;
    private doc;
    get class(): string;
    get display(): string;
    triggerElement: HTMLElement;
    scrollElement: HTMLElement;
    pageName: string;
    title: string;
    content: string;
    stepsCount: number;
    stepIndex: number;
    position: string;
    leftFix: number;
    topFix: number;
    zIndex: number;
    extraConfig: ExtraConfig;
    dots: Array<undefined>;
    subScriber: Subscription;
    SCROLL_REFRESH_INTERVAL: number;
    i18nCommonText: I18nInterface['stepsGuide'];
    DOT_HORIZONTAL_MARGIN: number;
    DOT_VERTICAL_MARGIN: number;
    document: Document;
    constructor(stepService: StepsGuideService, renderer: Renderer2, positionService: PositionService, elm: ElementRef, i18n: I18nService, doc: any);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    updatePosition(): void;
    next(): void;
    prev(): void;
    closeAll(): void;
    close(step: any, type?: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<StepsGuideComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<StepsGuideComponent, "ng-component", never, {}, {}, never, never, false, never>;
}
