import { EventEmitter, OnDestroy, OnInit, TemplateRef } from '@angular/core';
import { I18nInterface, I18nService } from 'ng-devui/i18n';
import { Subscription } from 'rxjs';
import { FileUploader } from './file-uploader.class';
import { IUploadOptions, UploadStatus } from './file-uploader.types';
import { UploadComponent } from './upload.class';
import { UploadedFilesComponent } from './uploaded-files.component';
import * as i0 from "@angular/core";
export declare class MultipleUploadViewComponent extends UploadComponent implements OnDestroy, OnInit {
    private i18n;
    uploadedFilesComponent: UploadedFilesComponent;
    uploadOptions: IUploadOptions;
    preloadFilesRef: TemplateRef<any>;
    uploadedFiles: Array<Object>;
    uploadedFilesRef: TemplateRef<any>;
    filePath: string;
    deleteUploadedFileEvent: EventEmitter<any>;
    setCustomUploadOptions: (files: any, uploadOptions: any) => IUploadOptions;
    UploadStatus: typeof UploadStatus;
    fileUploaders: Array<FileUploader>;
    i18nText: I18nInterface['upload'];
    i18nSubscription: Subscription;
    constructor(i18n: I18nService);
    ngOnInit(): void;
    addFile(file: any): void;
    deleteFile(file: any): void;
    deletePreUploadFile(file: any): void;
    removeFiles(): void;
    deleteFileProxy: (file: any) => void;
    _onDeleteUploadedFile(filePath: string): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MultipleUploadViewComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MultipleUploadViewComponent, "d-multiple-upload-view", never, { "uploadOptions": "uploadOptions"; "preloadFilesRef": "preloadFilesRef"; "uploadedFiles": "uploadedFiles"; "uploadedFilesRef": "uploadedFilesRef"; "filePath": "filePath"; "setCustomUploadOptions": "setCustomUploadOptions"; }, { "deleteUploadedFileEvent": "deleteUploadedFileEvent"; }, never, never, false, never>;
}
