import { EventEmitter, OnDestroy, OnInit, TemplateRef } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { I18nInterface, I18nService } from 'ng-devui/i18n';
import { ToastService } from 'ng-devui/toast';
import { Observable, Subscription } from 'rxjs';
import { FileUploader } from './file-uploader.class';
import { IFileOptions, IUploadOptions, UploadStatus } from './file-uploader.types';
import { SelectFiles } from './select-files.utils';
import { SingleUploadViewComponent } from './single-upload-view.component';
import * as i0 from "@angular/core";
export declare class SingleUploadComponent implements OnDestroy, OnInit, ControlValueAccessor {
    private i18n;
    private selectFiles;
    private doc;
    private toastService;
    dSingleUploadView: any;
    uploadOptions: IUploadOptions;
    fileOptions: IFileOptions;
    autoUpload: boolean;
    withoutBtn: boolean;
    showTip: boolean;
    uploadedFiles: Array<Object>;
    uploadedFilesRef: TemplateRef<any>;
    preloadFilesRef?: TemplateRef<any>;
    filePath: string;
    placeholderText: string;
    uploadText: string;
    /**
     * @deprecated
     */
    confirmText: string;
    beforeUpload: (file: any) => boolean | Promise<boolean> | Observable<boolean>;
    dynamicUploadOptionsFn: (files: any, uploadOptions: any) => IUploadOptions;
    enableDrop: boolean;
    disabled: boolean;
    successEvent: EventEmitter<Array<{
        file: File;
        response: any;
    }>>;
    errorEvent: EventEmitter<{
        file: File;
        response: any;
    }>;
    errorChunkEvent: EventEmitter<{
        file: File;
        response: any;
    }>;
    deleteUploadedFileEvent: EventEmitter<string>;
    fileDrop: EventEmitter<any>;
    fileOver: EventEmitter<boolean>;
    fileSelect: EventEmitter<File>;
    singleUploadViewComponent: SingleUploadViewComponent;
    UploadStatus: typeof UploadStatus;
    isDropOVer: boolean;
    defaultChunkSize: number;
    i18nText: I18nInterface['upload'];
    i18nCommonText: I18nInterface['common'];
    i18nSubscription: Subscription;
    errorMsg: any[];
    document: Document;
    private onChange;
    private onTouched;
    constructor(i18n: I18nService, selectFiles: SelectFiles, doc: any, toastService: ToastService);
    writeValue(files: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    simulateSelectFiles(files: any): Promise<unknown>;
    ngOnInit(): void;
    _dealFiles(observale: any): void;
    checkValid(): void;
    onClick($event: any): void;
    get filename(): string;
    onFileDrop(files: any): void;
    onFileOver(event: any): void;
    onFileSelect(file: any): void;
    upload(): void;
    isNeedChunk(): number | true;
    sliceUpload(): Promise<void>;
    uploadChunkList(fileChunkList: any, currentFile: any): Promise<Observable<unknown[]>>;
    createFileChunk(file: File): FileUploader[];
    canUpload(): Promise<boolean>;
    _onDeleteUploadedFile(filePath: string): void;
    deleteFile($event: any): void;
    alertMsg(errorMsg: any): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SingleUploadComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SingleUploadComponent, "d-single-upload", ["dSingleUpload"], { "uploadOptions": "uploadOptions"; "fileOptions": "fileOptions"; "autoUpload": "autoUpload"; "withoutBtn": "withoutBtn"; "showTip": "showTip"; "uploadedFiles": "uploadedFiles"; "uploadedFilesRef": "uploadedFilesRef"; "preloadFilesRef": "preloadFilesRef"; "filePath": "filePath"; "placeholderText": "placeholderText"; "uploadText": "uploadText"; "confirmText": "confirmText"; "beforeUpload": "beforeUpload"; "dynamicUploadOptionsFn": "dynamicUploadOptionsFn"; "enableDrop": "enableDrop"; "disabled": "disabled"; }, { "successEvent": "successEvent"; "errorEvent": "errorEvent"; "errorChunkEvent": "errorChunkEvent"; "deleteUploadedFileEvent": "deleteUploadedFileEvent"; "fileDrop": "fileDrop"; "fileOver": "fileOver"; "fileSelect": "fileSelect"; }, never, never, false, never>;
}
